unit mysnobol;
{Copyright 2009 Manfred Rosendahl
 Private Nutzung erlaubt
 Bei kommerzieller Nutzung bitte Mail an: ros at uni-koblenz.de
}
interface
uses //system in 'system.pas',
 sysutils,classes,mystring,myintarray;

var anchorglb:boolean=false;
 wasabort:boolean=false;
 wasfence:boolean=false;
 ignorecaseglb:boolean=false;
 greedyglb:boolean=true; //Benutzt bei trep
var matanzahl:integer=0;
var firstanzahl:integer=0;
procedure doanchorglb(v:boolean);
procedure trace(mode:integer);overload;
procedure trace(mode:integer;name:string);overload;
procedure trace(mode:integer;name:string;atracestr:string);overload;
procedure anchor(a:integer);
procedure greedy(a:integer);
procedure debug(a:integer);
procedure ignorecase(a:integer);
function uppercase(s:string):string;
function lowercase(s:string):string;
var pram:^string;
var tracefile:text;
var traceoutput:boolean=true; // Zeigt an dass Trace auf Konsole
 debug1:boolean=false;
 debug2:boolean=false;
 tracestr:string[2]='{}';

type tcharset=set of char;
{
 tboolarrfunction=function(arr:array of pointer):boolean;
 tboolfunction=function:boolean;
 tboolpointerfunction=function(p:pointer):boolean;

 tarrproc=procedure(arr:array of pointer);
 tprocedure=procedure;
 tpointerproc=procedure(p:pointer);
}
const letters:tcharset=['A'..'Z','a'..'z','','','','','','',''];
 digits:tcharset=['0'..'9'];
 namechars:tcharset=['0'..'9','A'..'Z','a'..'z','','','','','','','','_'];
{}
type tvari=class
// wird benutzt um nur eine Variablen adresse zu halten
// fr Stringvariablen tsv benutzen
public
 v:pointer;
 constructor create(var x);
end;
function vari(var x):tvari;
{
function count(sl:array of string):integer;overload;
function count(sl:tmystringlist):integer;overload;
function count(arr:tarray):integer;overload;
function count(arr:array of const):integer;overload;
}
type tpattern=class(tobject)
// abstrakte Superklasse fr alle Pattern
public
 minlen:integer; //minimale Lnge
 v:pstring;      // Variable, wo der matchende String gespeichert wird
 constructor create;overload;
 constructor create(var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;virtual;
 function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;virtual;
 procedure trace(res:boolean;kind:string;const astr:string;apos:integer;alt,len:tobject);virtual;
end;
type tass=class(tpattern)
//
 left,right:pointer;
 n:integer;
 constructor create(var aleft,aright;an:integer);
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function ass(var aleft,aright;an:integer):tass;

type tproc=class(tpattern)
// Match den Leerstring fr p aus
 p:tarrproc;
 arr:array of pointer;
 ispointer:boolean;
 // arr=nil -> procedure
 // ispointer -> prointerproc
 // sonst -> arrproc
 constructor create(ap:tprocedure);overload;
 constructor create(ap:tpointerproc;apar:pointer);overload;
 constructor create(ap:tarrproc;aarr:array of const);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
// es wird ap(apar)aufgerufen und der Nullstring gematcht
function proc(ap:tpointerproc;apar:pointer):tproc;overload;
function proc(ap:tarrproc;aarr:array of const):tproc;overload;
function proc(ap:tprocedure):tproc;overload;

type tfunc=class(tpattern)
// Matcht den Leerstring, wenn die Funktion func true liefert
public
 func:tboolarrfunction;
 arr:array of pointer;
 ispointer:boolean;
 constructor create(afunc:tboolfunction);overload;
 constructor create(afunc:tboolpointerfunction;apar:pointer);overload;
 constructor create(afunc:tboolarrfunction;aarr:array of const);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
//wenn der Aufruf von afunc(apar) true liefert wird der Leerstring gematcht
function func(afunc:tboolfunction):tfunc;overload;
function func(afunc:tboolpointerfunction;apar:pointer):tfunc;overload;
function func(afunc:tboolarrfunction;aarr:array of const):tfunc;overload;

type tstri=class(tpattern) //Matcht String str
public
 str:string;
 constructor create(const astr:string);
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 function compute:string;virtual;
end;
// es wird der String astr gematcht
function stri(const astr:string):tstri;

type tsv=class(tstri) // Stringvariable, wie tstr aber wert wird bei matchfirst erst besetzt
public
 vv:pstring;
 constructor create(var av:string);
 function compute:string;override;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
// es wird der Wert von av eingesetzt
function sv(var av:string):tsv;overload;

type tcat=class(tsv)
 list:tlist;
 constructor create(aarr:array of const);
 function compute:string;override;
end;
// Ergebnis ist die Verkettung der Ergebnisse von aarr
function cat(aarr:array of const):tcat;overload;

type tstringfunction=function(s:string):string;

type tsf=class(tsv)
 f:tstringfunction;
 constructor create(af:tstringfunction;var s:string);
 function compute:string;override;
end;
function sf(af:tstringfunction;var s:string):tsf;

type tiv=class(tpattern) // Integer Value
public
 vi:pinteger;
 constructor create(var av:integer);
 function compute:integer;virtual;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 //function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
// Es wird der String gematcht, der dem Wert von av enstspricht
function iv(var av:integer):tiv;overload;
type tsumme=class(tiv)
 arr:tlist;
 constructor create(aarr:array of const);
 function compute:integer;override;
end;
// Es wird der String gematcht, der der Summe der Werte von avaarenstspricht
function summe(aarr:array of const):tsumme;overload;
type tminus=class(tiv)
 vminus:tiv;
 constructor create(av:tiv);
 function compute:integer;override;
end;
function minus(av:tiv):tminus;

type tpatfunction=function(arr:array of pointer):tpattern;

type tpref=class(tpattern)
public
 patf:tpatfunction;
 par:array of pointer;
 constructor create(apatf:tpatfunction);overload;
 constructor create(apatf:tpatfunction;apar:pointer);overload;
 constructor create(apatf:tpatfunction;apar:array of const);overload;
 constructor create(apatf:tpatfunction;var s:string);overload;
 constructor create(apatf:tpatfunction;apar:pointer;var s:string);overload;
 constructor create(apatf:tpatfunction;apar:array of const;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function pref(apatf:tpatfunction):tpref;overload;
function pref(apatf:tpatfunction;apar:pointer):tpref;overload;
function pref(apatf:tpatfunction;apar:array of const):tpref;overload;
function pref(apatf:tpatfunction;var s:string):tpref;overload;
function pref(apatf:tpatfunction;apar:pointer;var s:string):tpref;overload;
function pref(apatf:tpatfunction;apar:array of const;var s:string):tpref;overload;

type tbal=class(tpattern)
// Matcht balanzierten String mit Klammern
// String muss mit einem Klammer oder quotesymbol beginnen
// Bal hat keine Alternativen
public
 klaauf,klazu,quoteauf,quotezu:tlist;
 // klaauf[1] mit klazu[1] usw.
 // quoteauf[1] mit quotezu[1] usw.
 // Innerhalb der quote werden keine Klammern bercksichtigt
 slash:char;
 // Zeichen hinter slash wird nie als Klammer genmmen
 constructor create(const klastr,quotestr:string;aslash:char);overload;
 // Beispiel:create('([{}])') liefert Klammerpaare () [] und {}
 constructor create(const klastr,quotestr:string;aslash:char;var s:string);overload;
 constructor create(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char);overload;
 constructor create(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 //function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
// constructor create(klastr,quotestr:array of const;aslash:char);overload;
 // Beispiel:create('([{}])') liefert Klammerpaare () [] und {}
// constructor create(klastr,quotestr:array of const;aslash:char;var s:string);overload;
end;
function bal(const klastr:string):tbal;overload;
function bal(const klastr:string;var s:string):tbal;overload;
function quote(const quotestr:string):tbal;overload;
function quote(const quotestr:string;var s:string):tbal;overload;
function balquote(const klastr,quotestr:string;aslash:char):tbal;overload;
function balquote(const klastr,quotestr:string;aslash:char;var s:string):tbal;overload;
function balquote(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char):tbal;overload;
function balquote(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string):tbal;overload;

type tsbal=class(tpattern) // Matcht balanzierten String mit Klammern
public
 klaauf,klazu,quoteauf,quotezu:tlist;
 //klaaufa,klazua,quoteaufa,quotezua:tvararr;
 // klaauf[1] mit klazu[1] usw.
 // qoute Innerhalb der quote werden keine Klammern bercksichtigt
 slash:char;
 // Zeichen hinter slash wird nie als Klammer genmmen
 constructor create(const klastr,quotestr:string;aslash:char);overload;
 // Beispiel:create('([{}])') liefert Klammerpaare () [] und {}
 constructor create(const klastr,quotestr:string;aslash:char;var s:string);overload;
 constructor create(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char);overload;
 constructor create(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
// constructor create(klastr,quotestr:array of const;aslash:char);overload;
 // Beispiel:create('([{}])') liefert Klammerpaare () [] und {}
// constructor create(klastr,quotestr:array of const;aslash:char;var s:string);overload;
end;
function sbal(const klastr:string):tsbal;overload;
function sbal(const klastr:string;var s:string):tsbal;overload;
function squote(const quotestr:string):tsbal;overload;
function squote(const quotestr:string;var s:string):tsbal;overload;
{
function sbalquote(const klastr,quotestr:string):tsbal;overload;
function sbalquote(const klastr,quotestr:string;var s:string):tsbal;overload;
}
function sbalquote(const klastr,quotestr:string;aslash:char):tsbal;overload;
function sbalquote(const klastr,quotestr:string;aslash:char;var s:string):tsbal;overload;
function sbalquote(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char):tsbal;overload;
function sbalquote(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string):tsbal;overload;


type tany=class(tpattern) //Matcht jedes zeichen aus chars
public
 chars:tcharset;
 vv:tsv;
 constructor create(const astr:string);overload;
 constructor create(const achars:tcharset);overload;
 constructor create(const astr:string;var s:string);overload;
 constructor create(const achars:tcharset;var s:string);overload;
 constructor create(avv:tsv);overload;
 constructor create(avv:tsv;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function any(const astr:string):tany;overload;
function any(const achars:tcharset):tany;overload;
function any(const astr:string;var s:string):tany;overload;
function any(const achars:tcharset;var s:string):tany;overload;
function any(avv:tsv):tany;overload;
function any(avv:tsv;var s:string):tany;overload;

type tnotany=class(tpattern) //Matcht jedes zeichen nicht in chars
public
 chars:tcharset;
 vv:tsv;
 constructor create(const astr:string);overload;
 constructor create(const achars:tcharset);overload;
 constructor create(const astr:string;var s:string);overload;
 constructor create(const achars:tcharset;var s:string);overload;
 constructor create(avv:tsv);overload;
 constructor create(avv:tsv;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function notany(const astr:string):tnotany;overload;
function notany(const achars:tcharset):tnotany;overload;
function notany(const astr:string;var s:string):tnotany;overload;
function notany(const achars:tcharset;var s:string):tnotany;overload;
function notany(avv:tsv):tnotany;overload;
function notany(avv:tsv;var s:string):tnotany;overload;

type tspan=class(tpattern) //matcht den lngsten String, der nur aus Zeichen aus chars besteht;
// bei null=true auch den leeren String
public
 null:boolean;
 chars:tcharset;
 vv:tsv;
 constructor create(const astr:string;anull:boolean);overload;
 constructor create(const achars:tcharset;anull:boolean);overload;
 constructor create(const astr:string;anull:boolean;var s:string);overload;
 constructor create(const achars:tcharset;anull:boolean;var s:string);overload;
 constructor create(avv:tsv;anull:boolean);overload;
 constructor create(avv:tsv;anull:boolean;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
// Es werden die folgenden Zeichen aus astr gematcht, auch der Nullstring
function span(const astr:string):tspan;overload;
function span(const achars:tcharset):tspan;overload;
function span(const astr:string;var s:string):tspan;overload;
function span(const achars:tcharset;var s:string):tspan;overload;
function span(avv:tsv):tspan;overload;
function span(avv:tsv;var s:string):tspan;overload;
// Bei anyspan muss midestens ein Zeichen aus astr folgen
function anyspan(const astr:string):tspan;overload;
function anyspan(const achars:tcharset):tspan;overload;
function anyspan(const astr:string;var s:string):tspan;overload;
function anyspan(const achars:tcharset;var s:string):tspan;overload;
function anyspan(avv:tsv):tspan;overload;
function anyspan(avv:tsv;var s:string):tspan;overload;

type tupto=class(tpattern) //matcht den lngsten String, der nicht aus Zeichen aus chars besteht;
// notfalls auch den leeren String
public
 chars:tcharset;
 vv:tsv;
 constructor create(const astr:string);overload;
 constructor create(const achars:tcharset);overload;
 constructor create(const astr:string;var s:string);overload;
 constructor create(const achars:tcharset;var s:string);overload;
 constructor create(avv:tsv);overload;
 constructor create(avv:tsv;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function upto(const astr:string):tupto;overload;
function upto(const achars:tcharset):tupto;overload;
function upto(const astr:string;var s:string):tupto;overload;
function upto(const achars:tcharset;var s:string):tupto;overload;
function upto(avv:tsv):tupto;overload;
function upto(avv:tsv;var s:string):tupto;overload;

type tlen=class(tpattern) // Matcht jeden String der Lnge i
public
 i:integer;
 constructor create(ai:integer);overload;
 constructor create(ai:integer;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function len(ai:integer):tlen;overload;
function len(ai:integer;var s:string):tlen;overload;

type tarb=class(tpattern) // Matcht jeden String mit Lnge >=i bei i=0 also jeden String
public
 i:integer;
 constructor create(ai:integer);overload;
 constructor create(ai:integer;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function arb(ai:integer):tarb;overload;
function arb:tarb;overload; // i=0 Matcht jeden String
function arb(ai:integer;var s:string):tarb;overload;
function arb(var s:string):tarb;overload; // matcht jeden String

type tpat=class(tpattern) // Matcht jeden String, der die Patternfolge pat matcht
public
 pat:tlist;
 minrestlen:tintarray; //minimale Restlnge ab position i
 constructor create(apat:tpattern;var s:string);overload;
 constructor create(apat:tlist);overload;
 constructor create(apat:tlist;var s:string);overload;
 constructor create(apat:array of const);overload;
 constructor create(apat:array of const;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 procedure computeminrestlen;
 procedure tracepat(kind:string;i:integer;const astr:string;apos:integer;alt,len:tobject);virtual;
end;
function pat(apat:tpattern;var s:string):tpat;overload;
function pat(apat:array of const):tpat;overload;
// Matcht die Patternfolge apat
function pat(apat:array of const;var s:string):tpat;overload;
function pat(astr:string):tstri;overload;
// Matcht den den String astr
function pat(ai:integer):tarb;overload;
// Matcht String mit Lnge >=ai
function pat(ai:integer;var s:string):tarb;overload;

type talt=class(tpattern) // Matcht jede der Alternativen in der Liste alterl
public
 alterl:tlist;
 constructor create(aalt:array of const);overload;
 constructor create(aalt:array of const;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 procedure tracealt(kind:string;i:integer;const astr:string;apos:integer;alt,len:tobject);virtual;
end;
function alt(aalt:array of const):talt;overload;
function alt(aalt:array of const;var s:string):talt;overload;

type tnon=class(tpattern) // Matcht denLeerstring, wennn das Pattern apat nicht matcht
public
 pat:tpattern;
 constructor create(apat:tpattern);overload;
 constructor create(apat:array of const);overload;
 constructor create(astr:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function non(apat:tpattern):tnon;overload;
function non(apat:array of const):tnon;overload;
function non(astr:string):tnon;overload;


type tlook=class(tpattern) // lookahed
// Matcht das Pattern pat, wenn danach das Pattern lpat folgt
// Zurck geliefert wird der String bis lpat
public
 pat:tpattern; // pattern das gesucht wird
 // ist apat=nil wird jeder String gematcht, der von lpat gefolgt wird
 lpat:tpattern; // lookahead pattern
 anchor:boolean; // das pattern pat muss nicht sofort kommen, wenn anchor false ist
 constructor create(alpat:tpattern);overload;
 constructor create(alpat:tpattern;var s:string);overload;
 constructor create(apat,alpat:tpattern;aanchor:boolean);overload;
 constructor create(apat,alpat:tpattern;aanchor:boolean;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function look(alpat:tpattern):tlook;overload;
//String bis alpat
function look(alpat:tpattern;var s:string):tlook;overload;
function look(apat,alpat:tpattern;aanchor:boolean):tlook;overload;
// bis apat gefolgt von alpat kommt
// Zurck geliefert wird String bis alpat
// Bei anchor=false knnen vor apat noch beliebige Zeichen kommen
function look(apat,alpat:tpattern;aanchor:boolean;var s:string):tlook;overload;

type tfind=class(tpattern)
// Es wird ein Auftreten von pat gesucht
// Wenn Klaauf und Klazu <>nil oder quote<>nil wird nicht innerhalb derKlammergebirge
// und der Quotierung gesucht
// Zurckgeliefert wird der String bis pat
public
 pat:tpattern; //pattern das gesucht wird
// vbis:pstring;   // string bis zu beginn des pattern pat
 klaauf,klazu,quoteauf,quotezu:tlist;
 // klaauf[1] mit klazu[1] usw.
 // qoute Innerhalb der quote werden keine Klammern bercksichtigt
 slash:char;
 // Zeichen hinter slash wird nie als Klammer genommen
 constructor create(apat:tpattern);overload;
 constructor create(apat:tpattern;var s:string);overload;
 // Beispiel:create(';(;[;{;};];)') liefert Klammerpaare () [] und {} 1.Zeichen ist Trenner
 constructor create(apat:tpattern;const klastr,quotestr:string;aslash:char);overload;
 constructor create(apat:tpattern;const klastr,quotestr:string;aslash:char;var s:string);overload;
 constructor create(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char);overload;
 constructor create(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function find(apat:tpattern):tfind;overload;
function find(apat:tpattern;var s:string):tfind;overload;
function find(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char):tfind;overload;
function find(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string):tfind;overload;
function findb(apat:tpattern;const klastr:string):tfind;overload;
// Beispiel:find(';(;[;{;};];)') liefert Klammerpaare () [] und {}  1. Zeichen ist Trenner
function findb(apat:tpattern;const klastr:string;var s:string):tfind;overload;
function findbq(apat:tpattern;const klastr,quotestr:string):tfind;overload;
//function findbq(apat:tpattern;const klastr,quotestr:string;var s:string):tfind;overload;
function findbq(apat:tpattern;const klastr,quotestr:string;aslash:char):tfind;overload;
function findbq(apat:tpattern;const klastr,quotestr:string;aslash:char;var s:string):tfind;overload;
function findq(apat:tpattern;const quotestr:string):tfind;overload;
//Beispiel: find(';{;(*;*);}') liefert die Paare { } und (* *) 1. Zeichen ist Trenner
//function findq(apat:tpattern;const quotestr:string;var s:string):tfind;overload;
function findq(apat:tpattern;const quotestr:string;aslash:char):tfind;overload;
function findq(apat:tpattern;const quotestr:string;aslash:char;var s:string):tfind;overload;
function find(const astr:string):tfind;overload;
function find(const astr:string;var s:string):tfind;overload;
function findb(const astr:string;const klastr:string):tfind;overload;
function findb(const astr:string;const klastr:string;var s:string):tfind;overload;
function findbq(const astr:string;const klastr,quotestr:string):tfind;overload;
//function findbq(const astr:string;const klastr,quotestr:string;var s:string):tfind;overload;
function findbq(const astr:string;const klastr,quotestr:string;aslash:char):tfind;overload;
function findbq(const astr:string;const klastr,quotestr:string;aslash:char;var s:string):tfind;overload;
function findq(const astr:string;const quotestr:string):tfind;overload;
//function findq(const astr:string;const quotestr:string;var s:string):tfind;overload;
function findq(const astr:string;const quotestr:string;aslash:char):tfind;overload;
function findq(const astr:string;const quotestr:string;aslash:char;var s:string):tfind;overload;

type tfindwith=class(tfind)
// Es wird ein Auftreten von pat gesucht
// Wenn Klaauf und Klazu <>nil oder quote<>nil wird nicht innerhalb derKlammergebirge
// und der Quotierung gesucht
// Zurckgeliefert wird der String bis pat
public
 vpat:pstring;      // Variable, wo der matchende String gespeichert wird
 constructor create(apat:tpattern);overload;
 constructor create(apat:tpattern;var s,spat:string);overload;
 // Beispiel:create(';(;[;{;};];)') liefert Klammerpaare () [] und {} 1.Zeichen ist Trenner
 constructor create(apat:tpattern;const klastr,quotestr:string;aslash:char);overload;
 constructor create(apat:tpattern;const klastr,quotestr:string;aslash:char;var s,spat:string);overload;
 constructor create(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char);overload;
 constructor create(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s,spat:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function findwith(apat:tpattern):tfindwith;overload;
function findwith(apat:tpattern;var s,spat:string):tfindwith;overload;
function findwith(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char):tfindwith;overload;
function findwith(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s,spat:string):tfindwith;overload;
function findwith(const astr:string):tfindwith;overload;
function findwith(const astr:string;var s,spat:string):tfindwith;overload;
function findwithb(apat:tpattern;const klastr:string):tfindwith;overload;
// Beispiel:findwith(';(;[;{;};];)') liefert Klammerpaare () [] und {}  1. Zeichen ist Trenner
function findwithb(apat:tpattern;const klastr:string;var s,spat:string):tfindwith;overload;
function findwithb(const astr:string;const klastr:string):tfindwith;overload;
function findwithb(const astr:string;const klastr:string;var s,spat:string):tfindwith;overload;
function findwithbq(apat:tpattern;const klastr,quotestr:string):tfindwith;overload;
//function findwithbq(apat:tpattern;const klastr,quotestr:string;var s,spat:string):tfindwith;overload;
function findwithbq(apat:tpattern;const klastr,quotestr:string;aslash:char):tfindwith;overload;
function findwithbq(apat:tpattern;const klastr,quotestr:string;aslash:char;var s,spat:string):tfindwith;overload;
function findwithbq(const astr:string;const klastr,quotestr:string):tfindwith;overload;
//function findwithbq(const astr:string;const klastr,quotestr:string;var s,spat:string):tfindwith;overload;
function findwithbq(const astr:string;const klastr,quotestr:string;aslash:char):tfindwith;overload;
function findwithbq(const astr:string;const klastr,quotestr:string;aslash:char;var s,spat:string):tfindwith;overload;
function findwithq(const astr:string;const quotestr:string):tfindwith;overload;
//function findwithq(const astr:string;const quotestr:string;var s,spat:string):tfindwith;overload;
function findwithq(const astr:string;const quotestr:string;aslash:char):tfindwith;overload;
function findwithq(const astr:string;const quotestr:string;aslash:char;var s,spat:string):tfindwith;overload;
function findwithq(apat:tpattern;const quotestr:string):tfindwith;overload;
//Beispiel: findwith(';{;(*;*);}') liefert die Paare { } und (* *) 1. Zeichen ist Trenner
//function findwithq(apat:tpattern;const quotestr:string;var s,spat:string):tfindwith;overload;
function findwithq(apat:tpattern;const quotestr:string;aslash:char):tfindwith;overload;
function findwithq(apat:tpattern;const quotestr:string;aslash:char;var s,spat:string):tfindwith;overload;

type trep=class(tpattern)
// Wenn not greedy:Matcht jede Anzahl von Wiederholungen des Pattern pat zwischen von und bis
// Sonst: matcht die lngste Folge von Wiederholungen des Pattern pat zwischen von und bis
// bis=0:  keine obere Schranke
public
 pat:tpattern;
 von,bis:integer;
 greedy:boolean;
 constructor create(apat:tpattern;avon,abis:integer;agreedy:boolean);overload;
 constructor create(apat:array of const;avon,abis:integer;agreedy:boolean);overload;
 constructor create(const s:string;avon,abis:integer;agreedy:boolean);overload;
 constructor create(apat:tpattern;avon,abis:integer;agreedy:boolean;var s:string);overload;
 constructor create(apat:array of const;avon,abis:integer;agreedy:boolean;var s:string);overload;
 constructor create(const ss:string;avon,abis:integer;agreedy:boolean;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
 function matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function rep(apat:tpattern;avon,abis:integer;agreedy:boolean):trep;overload;
function rep(apat:array of const;avon,abis:integer;agreedy:boolean):trep;overload;
function rep(const s:string;avon,abis:integer;agreedy:boolean):trep;overload;
function rep(apat:tpattern;avon,abis:integer;agreedy:boolean;var s:string):trep;overload;
function rep(apat:array of const;avon,abis:integer;agreedy:boolean;var s:string):trep;overload;
function rep(const ss:string;avon,abis:integer;agreedy:boolean;var s:string):trep;overload;
function rep(apat:tpattern;anzahl:integer):trep;overload;
function rep(apat:tpattern;anzahl:integer;var s:string):trep;overload;

function star(apa:tpattern):trep;overload;
// Matcht jede Anzahl, auch den Nullstring, d.h von=0 und bis=0
function star(apa:array of const):trep;overload;
function star(const s:string):trep;overload;
function star(apa:tpattern;var s:string):trep;overload;
function star(apa:array of const;var s:string):trep;overload;
function star(const ss:string;var s:string):trep;overload;

function star(apa:tpattern;agreedy:boolean):trep;overload;
function star(apa:array of const;agreedy:boolean):trep;overload;
function star(const s:string;agreedy:boolean):trep;overload;
function star(apa:tpattern;agreedy:boolean;var s:string):trep;overload;
function star(apa:array of const;agreedy:boolean;var s:string):trep;overload;
function star(const ss:string;agreedy:boolean;var s:string):trep;overload;


function plus(apa:tpattern):trep;overload;
// Matcht jede Anzahl, aber nicht den Nullstring, d.h von=1 und bis=0
function plus(apa:array of const):trep;overload;
function plus(const s:string):trep;overload;
function plus(apa:tpattern;var s:string):trep;overload;
function plus(apa:array of const;var s:string):trep;overload;
function plus(const ss:string;var s:string):trep;overload;

function plus(apa:tpattern;agreedy:boolean):trep;overload;
function plus(apa:array of const;agreedy:boolean):trep;overload;
function plus(const s:string;agreedy:boolean):trep;overload;
function plus(apa:tpattern;agreedy:boolean;var s:string):trep;overload;
function plus(apa:array of const;agreedy:boolean;var s:string):trep;overload;
function plus(const ss:string;agreedy:boolean;var s:string):trep;overload;

function opt(apa:tpattern):trep;overload;
// Matcht Pattern apa oder den Nullstring, d.h von=0 und bis=1
function opt(apa:array of const):trep;overload;
function opt(const s:string):trep;overload;
function opt(apa:tpattern;var s:string):trep;overload;
function opt(apa:array of const;var s:string):trep;overload;
function opt(const ss:string;var s:string):trep;overload;

function opt(apa:tpattern;agreedy:boolean):trep;overload;
function opt(apa:array of const;agreedy:boolean):trep;overload;
function opt(const s:string;agreedy:boolean):trep;overload;
function opt(apa:tpattern;agreedy:boolean;var s:string):trep;overload;
function opt(apa:array of const;agreedy:boolean;var s:string):trep;overload;
function opt(const ss:string;agreedy:boolean;var s:string):trep;overload;

type tcurs=class(tpattern)
// Matcht den Leerstring, und liefert die Cursorposition zurck
public
 posref:^integer;
 constructor create(var apos:integer);
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function curs(var apos:integer):tcurs;

type tlpos=class(tpattern)
// Matcht den Leerstring, wenn sich der Cursor an der Position posi befindet
public
 posi:integer;
 vv:tiv;
 constructor create(aposi:integer);overload;
 constructor create(av:tiv);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function lpos(aposi:integer):tlpos;overload;
function lpos(av:tiv):tlpos;overload;

type trpos=class(tpattern)
// Matcht den Leerstring, wenn sich der Cursor an der Position posi vor den Stringende befindet
public
 posi:integer;
 vv:tiv;
 constructor create(aposi:integer);overload;
 constructor create(av:tiv);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function rpos(aposi:integer):trpos;overload;
function rpos(av:tiv):trpos;overload;

type ttab=class(tpattern)
// Matcht den String, von der aktuellen Cursorposition bis zur Position tabi
// Ist der Corsor schon hinter tabi kein matching
public
 tabi:integer;
 vv:tiv;
 constructor create(atabi:integer);overload;
 constructor create(av:tiv);overload;
 constructor create(atabi:integer;var s:string);overload;
 constructor create(av:tiv;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function tab(atabi:integer):ttab;overload;
function tab(atabi:integer;var s:string):ttab;overload;
function tab(av:tiv):ttab;overload;
function tab(av:tiv;var s:string):ttab;overload;

type trtab=class(tpattern)
// Matcht den String, von der aktuellen Cursorposition bis zur Position tabi vor Stringende
// Ist der Corsor schon weniger als tabi vom Stringende kein matching
public
 tabi:integer;
 vv:tiv;
 constructor create(atabi:integer);overload;
 constructor create(av:tiv);overload;
 constructor create(atabi:integer;var s:string);overload;
 constructor create(av:tiv;var s:string);overload;
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function rtab(atabi:integer):trtab;overload;
function rtab(atabi:integer;var s:string):trtab;overload;
function rtab(av:tiv):trtab;overload;
function rtab(av:tiv;var s:string):trtab;overload;
function rem:trtab;overload;
function rem(var s:string):trtab;overload;


type tabort=class(tpattern) // bricht ab
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function abort:tabort;

type tfail=class(tpattern) //immer fail
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function fail:tfail;

type tfence=class(tpattern)  // stop bei bachtracking
end;
function fence:tfence;

type tcrlf=class(tpattern)  // Matcht die Zeichenfolge crlf
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function crlf:tcrlf;

type twordstart=class(tpattern)
// Matcht den Leerstring, wenn sich der Cursor am Wortanfang befindet
// d.h. hinter dem Cursor ein Zeichen aus namechars und davor ein Zeichen nicht aus namechars
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function wordstart:twordstart;
type twordend=class(tpattern)
// Matcht den Leerstring, wenn sich der Cursor am Wortende befindet
// d.h. vor dem Cursor ein Zeichen aus namechars und dahinter ein Zeichen nicht aus namechars
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function wordend:twordend;
(*
type tsub=class(tsv)
// bei der Funktion replace werden die gematchten Teile durch die Strings aus tsub ersetzt
public
 subl:tlist;
 constructor create(const s:string);overload;
 constructor create(arr:array of const);overload;
 constructor createvar(s:string);overload;
end;
function sub(const s:string):tsub;overload;
function sub(arr:array of const):tsub;overload;
function subv(s:string):tsub;overload;
// x eine Stringvariable, die den zu erstzenden String enthlt
// diese kann vorher beim Matching gesetzt werden
*)

type trepl=class(tpattern)
 pat:tpattern;
 sub:tsv;
 constructor create(apat:tpattern;asub:tsv);
 function matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;override;
end;
function repl(apat:tpattern;asub:tsv):trepl;overload;
function repl(apat:array of const;asub:tsv):trepl;overload;
function repl(apat:array of const;asub:array of const):trepl;overload;
function repl(apat:tpattern;asub:array of const):trepl;overload;

function mat(s:string;ab:integer;const pat:tpattern;var apos,alen:integer):boolean;
overload;
// Test:matcht s pat irgenwo ab ab wenn ja apos und alen setzen
// bei anchor=true muss ab ab gematcht werden
function mat(s:string;ab:integer;const pat:tpattern;var apos:integer;var s2:string):boolean;
overload;
// Test:matcht s pat ab ab irgenwo, wenn ja apos Position und s2 gematchter string
function mat(s:string;ab:integer;const pat:tpattern;var s2:string):boolean;
overload;
// Test:matcht s pat ab ab irgenwo, wenn ja s2 gematchter string
function mat(s:string;ab:integer;const pat:tpattern):boolean;
overload;

function mat(s:string;ab:integer;par:array of const):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo
function mat(s:string;ab:integer;par:array of const;var apos,alen:integer):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja apos Position und alen Lnge desgematchten String
function mat(s:string;ab:integer;par:array of const;var apos:integer;var s2:string):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja apos Position und s2 gematchter string
function mat(s:string;ab:integer;par:array of const;var s2:string):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja s2 gematchter string

function mat(s:string;ab:integer;const s2:string;var apos:integer):boolean;
overload;
// Test:matcht s den String s2 ab ab irgenwo, wenn ja apos Position

function mat(s:string;const pat:tpattern;var apos,alen:integer):boolean;
overload;
// Test:matcht s pat irgenwo ab ab wenn ja apos und alen setzen
// bei anchor=true muss ab ab gematcht werden
function mat(s:string;const pat:tpattern;var apos:integer;var s2:string):boolean;
overload;
// Test:matcht s pat ab ab irgenwo, wenn ja apos Position und s2 gematchter string
function mat(s:string;const pat:tpattern;var s2:string):boolean;
overload;
// Test:matcht s pat ab ab irgenwo, wenn ja s2 gematchter string
function mat(s:string;const pat:tpattern):boolean;
overload;

function mat(s:string;par:array of const):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo
function mat(s:string;par:array of const;var apos,alen:integer):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja apos Position und alen Lnge desgematchten String
function mat(s:string;par:array of const;var apos:integer;var s2:string):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja apos Position und s2 gematchter string
function mat(s:string;par:array of const;var s2:string):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja s2 gematchter string

function mat(s:string;const s2:string;var apos:integer):boolean;
overload;
// Test:matcht s den String s2 ab ab irgenwo, wenn ja apos Position

function mat0(s:string;ab:integer;pat:tobject;var alen:integer):boolean;
(*
function multisubstitute(s:string;ab:integer;par:array of const;var apos,alen:integer):boolean;
overload;
// s wird ab ab gematcht ;gematchter string beginn bei apos
// Positionen beginnen bei 0 !!
// in par enthlt jeder Eintrag tsub einen String, der den zuvor gematchten ersetzt
// jedoch nur bei gesamterfolg
// alen gibt die Lnge des gematchten Strings nach den Ersetzungen
function substitute(const s:string;ab:integer;pat:tpattern;newstr:array of const;
         var succ:boolean;rep:boolean=false;rek:boolean=false):string;overload;
// s wird ab ab gematcht ;gematchter string wird ersetzt durch newstr
// Positionen beginnen bei 0 !!
//
function substitute(const s:string;ab:integer;arr:array of const;newstr:array of const;
         var succ:boolean;rep:boolean=false;rek:boolean=false):string;overload;
// s wird ab ab gematcht ;gematchter string wird ersetzt durch newstr
// Positionen beginnen bei 0 !!
//

function substitute(const s:string;arr:array of const;newstr:array of const;
         rep:boolean=false;rek:boolean=false):string;overload;

function match(s:string;pat:tpattern;rep:boolean=false):string;
*)

function replace(const s:string;pat:tpattern;newstr:tstri;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;overload;
// s wird ab ab gematcht ;gematchter string beginn bei apos und hat Lnge alen
// er wird ersetzt durch substr
// Positionen beginn bei 0 !!
// Funktionswert: der neue string
//
function replace(const s:string;arr:array of const;newstr:tstri;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;overload;
function replace(const s:string;pat:tpattern;newstr:string;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;overload;
function replace(const s:string;arr:array of const;newstr:string;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;overload;
function replace(const s:string;pat:tpattern;newstr:array of const;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;overload;
function replace(const s:string;arr:array of const;newstr:array of const;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;overload;

function match(s:string;pat:tpattern;rep:boolean=false;rek:boolean=false;ancho:boolean=false;
         trenner:string='';ab:integer=0):string;overload;
function match(s:string;arr:array of const;rep:boolean=false;rek:boolean=false;ancho:boolean=false;trenner:string='';ab:integer=0):string;overload;

function matchall(s:string;ab:integer;pat:tpattern;var apos:arrayofinteger;var sl:arrayofstring):integer;
overload;
// In s werden alle Teilstrings, die pat matchen ermittelt; apos liefert die Positionen und sl die
// gematchten Strings
// Beispiel: matchall(ss,0,name,apos,sl) liefert alle Namen in ss

function matchall(s:string;ab:integer;pat:array of const;var apos:arrayofinteger;var sl:arrayofstring):integer;
overload;
// Analog mit der Paternfolge pat

function matchall(s:string;ab:integer;pat:tpattern;var sl:arrayofstring):integer;
overload;
// In s werden alle Teilstrings, die pat matchen ermittelt; sl liefert die gematchten Strings
// Beispiel: matchall(ss,0,name,sl) liefert alle Namen in ss

function matchall(s:string;ab:integer;pat:array of const;var sl:arrayofstring):integer;
overload;
// Analog mit der Paternfolge pat

function matchall(s:string;pat:tpattern;var apos:arrayofinteger;var sl:arrayofstring):integer;
overload;
// In s werden alle Teilstrings, die pat matchen ermittelt; apos liefert die Positionen und sl die
// gematchten Strings
// Beispiel: matchall(ss,0,name,apos,sl) liefert alle Namen in ss

function matchall(s:string;pat:array of const;var apos:arrayofinteger;var sl:arrayofstring):integer;
overload;
// Analog mit der Paternfolge pat

function matchall(s:string;pat:tpattern;var sl:arrayofstring):integer;
overload;
// In s werden alle Teilstrings, die pat matchen ermittelt; sl liefert die gematchten Strings
// Beispiel: matchall(ss,0,name,sl) liefert alle Namen in ss

function matchall(s:string;pat:array of const;var sl:arrayofstring):integer;
overload;
// Analog mit der Paternfolge pat

function list2string(list:tlist):string;
{
procedure substitutefile(const quelle,ziel:string;arr:array of const;
rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0);overload;

// in Datei quelle wird in jeder Zeile match(arr) gemacht
// die gnderten Zeile nach ziel
}
procedure substitutefile(const quelle,ziel:string;arr,newstr:array of const;
rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0);overload;
// in Datei quelle wird in jeder Zeile replace(arr,newstr) gemacht
// die gnderten Zeile nach ziel

function getfields(s:string):tstringlist;overload;
function getfields(s:string;quotestr:string):tstringlist;overload;
function getfields(s:string;trenner,quotestr:string;triml:boolean=false;trimr:boolean=false):tstringlist;
overload;

type tsubprocedure=procedure(const s1:string;var s2:string);
procedure filefilter(quelle,ziel:string;proc:tsubprocedure);
procedure textfilter(quelle,ziel:string;proc:tsubprocedure);
procedure filetest(quelle,ziel:string;proc:tsubprocedure);overload;
procedure filetest(quelle,ziel:string;proc:tsubprocedure;mitzeilennr:boolean);overload;
procedure filerename(qdir:string;proc:tsubprocedure);
procedure filecopy(qdir,zdir:string;proc:tsubprocedure);


var name:tpattern; // Matcht jeden Namen: pat([any(buchars),span(namechars)]);
 blanks:tpattern; // Matcht die lngste Folge von Blanks: span(' ');
 number:tpattern; // Matcht jede Integer Zahl

function getname(var s:string):tpattern;

implementation
uses windows;


function uppercase(s:string):string;
begin
result:=sysutils.UpperCase(s);
end;
function lowercase(s:string):string;
begin
result:=sysutils.lowerCase(s);
end;

procedure writetrace(const s:string);
begin
if traceoutput then writeln(s) else begin
 system.append(tracefile);
 writeln(tracefile,s);
 system.close(tracefile);
end;
end;
type tinteger=class(tobject)  // integer als object
 x:integer;
 constructor create(ax:integer);
end;
type tstring=class(tobject)
 s:string;
 constructor create(const ss:string);
end;

function strv(i:integer):string;
begin
system.str(i,result);
end;

function arr2list(arr:array of const):tlist;
var i:integer;
 x:tobject;
begin
if high(arr)<0 then result:=nil else begin
 result:=tlist.create;
 for i:=0 to high(arr) do with arr[i] do begin
  x:=nil;
  case vtype of
   vtinteger:x:=tinteger.create(vinteger);
   vtchar:x:=tstring.create(vchar);
   vtstring:x:=tstring.create(vstring^);
   vtansistring:x:=tstring.create(string(vansistring));
   vtobject:x:=vobject;
  end;
  if x<>nil then result.add(x);
 end;
end;
end;

function av(arr:array of const):tlist;
begin
result:=arr2list(arr);
end;

constructor tvari.create(var x);
begin
v:=@x;
end;
function vari(var x):tvari;
begin
result:=tvari.create(x);
end;


function laenge(a:tobject):integer; // Laenge bei len
var al:tlist;
 //altl:taltlist;
 i:integer;
begin
laenge:=0;
if a<>nil then begin
 if a is tinteger then result:=(a as tinteger).x
 else if a is tlist then begin
  al:=a as tlist;
  result:=0;
  for i:=0 to al.count-1 do begin
   result:=result+laenge(al[i]);
  end;
 end;
end;
end;

constructor tinteger.create(ax:integer);
begin
inherited create;
x:=ax;
end;

constructor tstring.create(const ss:string);
begin
inherited create;
s:=ss;
end;

constructor tpattern.create;
begin
inherited create;
minlen:=0;
end;
constructor tpattern.create(var s:string);
begin
create;
v:=@s;
end;
function tpattern.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
// erfolgreich den nullstring wenn arlen passt;keine Alternative
begin
alt:=nil;
len:=nil;
result:=(apos+arlen<=length(astr));
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function tpattern.matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
// fail immer
begin
result:=false;
//alt.free;
alt:=nil;
//len.free;  ???
len:=nil;
end;
procedure tpattern.trace(res:boolean;kind:string;const astr:string;apos:integer;alt,len:tobject);
begin
if classname='tfind'then begin
 apos:=apos;
end;
if res then begin
 if debug2 then writetrace(classname+' '+kind+':'+system.copy(astr,1,apos)+
  tracestr[1]+system.copy(astr,apos+1,laenge(len))+tracestr[2]+system.copy(astr,apos+1+laenge(len),255))
 else if debug1 then writetrace(classname+' '+kind+':'+tracestr[1]+system.copy(astr,apos+1,laenge(len))+tracestr[2]);
end else begin
 if debug2 then writetrace(classname+' '+kind+':'+system.copy(astr,1,apos)+tracestr[1]+'fail'+tracestr[2]+
 system.copy(astr,apos+1,255))
 else if debug1 then writetrace(classname+' '+kind+':[fail]');
end;
end;

constructor tass.create(var aleft,aright;an:integer);
begin
inherited create;
left:=@aleft;right:=@aright;
n:=an;
end;
function tass.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
result:=true;alt:=nil;len:=nil;
system.Move(right^,left^,n);
end;
function ass(var aleft,aright;an:integer):tass;
begin
result:=tass.create(aleft,aright,an);
end;
constructor tproc.create(ap:tprocedure);
begin
inherited create;
p:=tarrproc(ap);
arr:=nil;
end;
constructor tproc.create(ap:tpointerproc;apar:pointer);
begin
inherited create;
p:=tarrproc(ap);
setlength(arr,1);
arr[0]:=apar;
ispointer:=true;
end;
constructor tproc.create(ap:tarrproc;aarr:array of const);
var n,i:integer;
begin
inherited create;
p:=ap;
n:=high(aarr)+1;
setlength(arr,n);
for i:=0 to n-1 do arr[i]:=aarr[i].vpointer;
ispointer:=false;
end;
function tproc.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var pp:tprocedure;
 ppp:tpointerproc;
begin
result:=true;alt:=nil;len:=nil;
if arr=nil then begin
 pp:=tprocedure(p);pp;
end else if ispointer then begin
 ppp:=tpointerproc(p);
 ppp(arr[0]);
end else p(arr);
end;
function proc(ap:tprocedure):tproc;
begin
result:=tproc.create(ap);
end;
function proc(ap:tpointerproc;apar:pointer):tproc;
begin
result:=tproc.create(ap,apar);
end;
function proc(ap:tarrproc;aarr:array of const):tproc;
begin
result:=tproc.create(ap,aarr);
end;

constructor tfunc.create(afunc:tboolfunction);
begin
inherited create;
func:=tboolarrfunction(afunc);
arr:=nil;
end;
constructor tfunc.create(afunc:tboolpointerfunction;apar:pointer);
begin
inherited create;
func:=tboolarrfunction(afunc);
setlength(arr,1);
arr[0]:=apar;
ispointer:=true;
end;
constructor tfunc.create(afunc:tboolarrfunction;aarr:array of const);
var n,i:integer;
begin
inherited create;
func:=afunc;
n:=high(aarr)+1;
setlength(arr,n);
for i:=0 to n-1 do arr[i]:=aarr[i].VPointer;
ispointer:=false;
end;
function tfunc.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var ff:tboolfunction;
 fff:tboolpointerfunction;
begin
alt:=nil;len:=nil;
if arr=nil then begin
 ff:=tboolfunction(func);
 result:=ff;
end else if ispointer then begin
 fff:=tboolpointerfunction(func);
 result:=fff(arr[0]);
end else result:=func(arr);
if debug1 then trace(result,'',astr,apos,alt,len);
end;
function func(afunc:tboolfunction):tfunc;overload;
begin
result:=tfunc.create(afunc);
end;
function func(afunc:tboolpointerfunction;apar:pointer):tfunc;overload;
begin
result:=tfunc.create(afunc,apar)
end;
function func(afunc:tboolarrfunction;aarr:array of const):tfunc;overload;
begin
result:=tfunc.create(afunc,aarr)
end;

constructor tstri.create(const astr:string);
begin
inherited create;
str:=astr;
minlen:=length(astr);
end;
function tstri.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
alt:=nil;len:=nil;
if ignorecaseglb then
result:=(apos+length(str)+arlen<=length(astr))and (ansiuppercase(system.copy(astr,apos+1,length(str)))=uppercase(str))
else
result:=(apos+length(str)+arlen<=length(astr))and (system.copy(astr,apos+1,length(str))=str);
if result then begin
 len:=tinteger.create(length(str));
 if v<>nil then begin
  pointer(v^):=nil;
  v^:=system.copy(astr,apos+1,length(str));
 end; 
end;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function tstri.compute:string;
begin
result:=str;
end;
function stri(const astr:string):tstri;
begin
result:=tstri.create(astr);
end;

constructor tsv.create(var av:string);
begin
vv:=@av;
end;
function tsv.compute:string;
begin
result:=vv^;
end;
function tsv.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
str:=compute;
result:=inherited matchfirst(astr,apos,arlen,alt,len);
end;
function sv(var av:string):tsv;
begin
result:=tsv.create(av);
end;

constructor tcat.create(aarr:array of const);
begin
list:=arr2list(aarr);
end;
function tcat.compute:string;
begin
result:=list2string(list);
end;
function cat(aarr:array of const):tcat;
begin
result:=tcat.create(aarr);
end;

constructor tsf.create(af:tstringfunction;var s:string);
begin
f:=af;
vv:=@s;
end;
function tsf.compute:string;
begin
result:=f(vv^);
end;
function sf(af:tstringfunction;var s:string):tsf;
begin
result:=tsf.create(af,s);
end;

constructor tiv.create(var av:integer);
begin
vi:=@av;
end;
function iv(var av:integer):tiv;
begin
result:=tiv.create(av);
end;
function tiv.compute:integer;
begin
result:=vi^;
//str:=inttostr(result);
end;
function tiv.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
compute;
result:=inherited matchfirst(astr,apos,arlen,alt,len);
end;

constructor tsumme.create(aarr:array of const);
var i:integer;
 e:tobject;
begin
arr:=tlist.create;
for i:=0 to high(aarr) do begin
 e:=nil;
 with aarr[i] do case vtype of
  vtinteger:e:=tinteger.create(vinteger);
  vtobject:e:=vobject;
 end;
 if e<>nil then arr.add(e);
end;
end;
function tsumme.compute:integer;
var i:integer;
 e:tobject;
begin
result:=0;
for i:=0 to arr.count-1 do begin
 e:=tobject(arr[i]);
 if e is tinteger then inc(result,(e as tinteger).x)
 else if e is tiv then inc(result,(e as tiv).compute);
end;
//str:=inttostr(result);
end;
function summe(aarr:array of const):tsumme;
begin
result:=tsumme.create(aarr);
end;

constructor tminus.create(av:tiv);
begin
vminus:=av;
end;
function tminus.compute:integer;
begin
result:=-vminus.compute;
//str:=inttostr(result);
end;
function minus(av:tiv):tminus;
begin
result:=tminus.create(av);
end;

constructor tany.create(const astr:string);
var i:integer;
begin
inherited create;
chars:=[];
for i:=1 to length(astr) do chars:=chars+[astr[i]];
minlen:=1;
v:=nil;
end;
constructor tany.create(const achars:tcharset);
begin
chars:=achars;
minlen:=1;
v:=nil;
end;
constructor tany.create(const astr:string;var s:string);
begin
create(astr);v:=@s;
end;
constructor tany.create(const achars:tcharset;var s:string);
begin
create(achars);v:=@s;
end;
constructor tany.create(avv:tsv);
begin
vv:=avv;
minlen:=1;
v:=nil;
end;
constructor tany.create(avv:tsv;var s:string);
begin
create(avv);v:=@s;
end;
function tany.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var chup,chlow:char;
 s:string;
 i:integer;
begin
if vv<>nil then begin
 s:=vv.compute;
 chars:=[];
 for i:=1 to length(s) do chars:=chars+[s[i]];
end;
if ignorecaseglb then begin
 chup:=ansiuppercase(astr[apos+1])[1];chlow:=ansilowercase(chup)[1];
 result:=(apos+minlen+arlen<=length(astr))and ((chup in chars)or(chlow in chars));
end else
result:=(apos+minlen+arlen<=length(astr))and (astr[apos+1] in chars);
alt:=nil;
if result then begin
 len:=tinteger.create(1);
 if v<>nil then begin
  pointer(v^):=nil;
  v^:=astr[apos+1];
 end; 
end else len:=nil;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function any(const astr:string):tany;overload;
begin
result:=tany.create(astr);
end;
function any(const achars:tcharset):tany;overload;
begin
result:=tany.create(achars);
end;
function any(const astr:string;var s:string):tany;overload;
begin
result:=tany.create(astr,s);
end;
function any(const achars:tcharset;var s:string):tany;overload;
begin
result:=tany.create(achars,s);
end;
function any(avv:tsv):tany;overload;
begin
result:=tany.create(avv);
end;
function any(avv:tsv;var s:string):tany;overload;
begin
result:=tany.create(avv,s);
end;

constructor tnotany.create(const astr:string);
var i:integer;
begin
inherited create;
chars:=[];
for i:=1 to length(astr) do chars:=chars+[astr[i]];
minlen:=1;
end;
constructor tnotany.create(const achars:tcharset);
begin
chars:=achars;
minlen:=1;
end;
constructor tnotany.create(const astr:string;var s:string);
begin
create(astr);v:=@s;
end;
constructor tnotany.create(const achars:tcharset;var s:string);
begin
create(achars);v:=@s;
end;
constructor tnotany.create(avv:tsv);
begin
vv:=avv;
minlen:=1;
end;
constructor tnotany.create(avv:tsv;var s:string);
begin
create(avv);v:=@s;
end;
function tnotany.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var chup,chlow:char;
 s:string;
 i:integer;
begin
if vv<>nil then begin
 s:=vv.compute;
 chars:=[];
 for i:=1 to length(s) do chars:=chars+[s[i]];
end;
if ignorecaseglb then begin
 chup:=ansiuppercase(astr[apos+1])[1];chlow:=ansilowercase(chup)[1];
 result:=(apos+minlen+arlen<=length(astr))and (not(chup in chars))and (not(chlow in chars));
end else
result:=(apos+minlen+arlen<=length(astr))and not(astr[apos+1] in chars);
alt:=nil;
if result then begin
 len:=tinteger.create(1);
 if v<>nil then begin
  pointer(v^):=nil;v^:=astr[apos+1];
 end; 
end else len:=nil;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function notany(const astr:string):tnotany;overload;
begin
result:=tnotany.create(astr);
end;
function notany(const achars:tcharset):tnotany;overload;
begin
result:=tnotany.create(achars);
end;
function notany(const astr:string;var s:string):tnotany;overload;
begin
result:=tnotany.create(astr,s);
end;
function notany(const achars:tcharset;var s:string):tnotany;overload;
begin
result:=tnotany.create(achars,s);
end;
function notany(avv:tsv):tnotany;overload;
begin
result:=tnotany.create(avv);
end;
function notany(avv:tsv;var s:string):tnotany;overload;
begin
result:=tnotany.create(avv,s);
end;

constructor tspan.create(const astr:string;anull:boolean);
var i:integer;
begin
inherited create;
vv:=nil;
chars:=[];
for i:=1 to length(astr) do chars:=chars+[astr[i]];
minlen:=0;
null:=anull;
end;
constructor tspan.create(const achars:tcharset;anull:boolean);
begin
inherited create;
vv:=nil;
chars:=achars;
minlen:=0;
null:=anull;
end;
constructor tspan.create(const astr:string;anull:boolean;var s:string);
begin
create(astr,anull);v:=@s;
end;
constructor tspan.create(const achars:tcharset;anull:boolean;var s:string);
begin
create(achars,anull);v:=@s;
end;
constructor tspan.create(avv:tsv;anull:boolean);
begin
inherited create;
vv:=avv;
minlen:=1-ord(anull);
null:=anull;
end;
constructor tspan.create(avv:tsv;anull:boolean;var s:string);
begin
create(avv,anull);v:=@s;
end;
function tspan.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var i:integer;
 chup,chlow:char;
 s:string;
begin
if vv<>nil then begin
 s:=vv.compute;
 chars:=[];
 for i:=1 to length(s) do chars:=chars+[s[i]];
end;
i:=0;
if ignorecaseglb then begin
 while apos+i+arlen<length(astr) do begin
  chup:=ansiuppercase(astr[apos+i+1])[1];chlow:=ansilowercase(chup)[1];
  if not((chup in chars)or(chlow in chars))then break;
  i:=i+1;
 end;
end else begin
 while (apos+i+arlen<length(astr))and (astr[apos+i+1] in chars) do inc(i);
end;
result:=null or (i>0);
alt:=nil;len:=nil;
if result then begin
 len:=tinteger.create(i);
 if v<>nil then begin
  pointer(v^):=nil;
  v^:=system.copy(astr,apos+1,i);
 end; 
end;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function span(const astr:string):tspan;overload;
begin
result:=tspan.create(astr,true);
end;
function span(const achars:tcharset):tspan;overload;
begin
result:=tspan.create(achars,true);
end;
function span(const astr:string;var s:string):tspan;overload;
begin
result:=tspan.create(astr,true,s);
end;
function span(const achars:tcharset;var s:string):tspan;overload;
begin
result:=tspan.create(achars,true,s);
end;
function span(avv:tsv):tspan;overload;
begin
result:=tspan.create(avv,true);
end;
function span(avv:tsv;var s:string):tspan;overload;
begin
result:=tspan.create(avv,true,s);
end;

function anyspan(const astr:string):tspan;overload;
begin
result:=tspan.create(astr,false);
end;
function anyspan(const achars:tcharset):tspan;overload;
begin
result:=tspan.create(achars,false);
end;
function anyspan(const astr:string;var s:string):tspan;overload;
begin
result:=tspan.create(astr,false,s);
end;
function anyspan(const achars:tcharset;var s:string):tspan;overload;
begin
result:=tspan.create(achars,false,s);
end;
function anyspan(avv:tsv):tspan;overload;
begin
result:=tspan.create(avv,false);
end;
function anyspan(avv:tsv;var s:string):tspan;overload;
begin
result:=tspan.create(avv,false,s);
end;

constructor tupto.create(const astr:string);
var i:integer;
begin
inherited create;
chars:=[];
for i:=1 to length(astr) do chars:=chars+[astr[i]];
minlen:=0;
end;
constructor tupto.create(const achars:tcharset);
begin
chars:=achars;
minlen:=0;
end;
constructor tupto.create(const astr:string;var s:string);
begin
create(astr);v:=@s;
end;
constructor tupto.create(const achars:tcharset;var s:string);
begin
create(achars);v:=@s;
end;
constructor tupto.create(avv:tsv);
begin
vv:=avv;
minlen:=0;
end;
constructor tupto.create(avv:tsv;var s:string);
begin
create(avv);v:=@s;
end;
function tupto.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var i:integer;
 chup,chlow:char;
 s:string;
begin
if vv<>nil then begin
 s:=vv.compute;
 chars:=[];
 for i:=1 to length(s) do chars:=chars+[s[i]];
end;
i:=0;
if ignorecaseglb then begin
 while true do begin
  chup:=ansiuppercase(astr[apos+i+1])[1];chlow:=ansilowercase(chup)[1];
  if not (apos+i+arlen<length(astr))or (chup in chars)or(chlow in chars)then break;
  i:=i+1;
 end;
end else
while (apos+i+arlen<length(astr))and not(astr[apos+i+1] in chars) do inc(i);
result:=true;
alt:=nil;
len:=tinteger.create(i);
if v<>nil then begin
 pointer(v^):=nil;v^:=system.copy(astr,apos+1,i);
end; 
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function upto(const astr:string):tupto;overload;
begin
result:=tupto.create(astr);
end;
function upto(const achars:tcharset):tupto;overload;
begin
result:=tupto.create(achars);
end;
function upto(const astr:string;var s:string):tupto;overload;
begin
result:=tupto.create(astr,s);
end;
function upto(const achars:tcharset;var s:string):tupto;overload;
begin
result:=tupto.create(achars,s);
end;
function upto(avv:tsv):tupto;overload;
begin
result:=tupto.create(avv);
end;
function upto(avv:tsv;var s:string):tupto;overload;
begin
result:=tupto.create(avv,s);
end;

constructor tlen.create(ai:integer);
begin
inherited create;
i:=ai;
minlen:=ai;
end;
constructor tlen.create(ai:integer;var s:string);
begin
create(ai);
v:=@s;
end;
function tlen.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
result:=(apos+i+arlen<=length(astr));
alt:=nil;
if result then begin
 len:=tinteger.create(i);
 if v<>nil then begin
  pointer(v^):=nil;
  v^:=system.copy(astr,apos+1,i);
 end; 
end else len:=nil;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;

function len(ai:integer):tlen;overload;
begin
result:=tlen.create(ai);
end;
function len(ai:integer;var s:string):tlen;overload;
begin
result:=tlen.create(ai,s);
end;

constructor tarb.create(ai:integer);
begin
inherited create;
i:=ai;
minlen:=ai;
end;
constructor tarb.create(ai:integer;var s:string);
begin
create(ai);
v:=@s;
end;
function tarb.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
result:=(apos+i+arlen<=length(astr));
if result then begin
 alt:=tinteger.create(1);len:=tinteger.create(i);
 if v<>nil then begin
  pointer(v^):=nil;v^:=system.copy(astr,apos+1,i);
 end; 
end else begin
 alt:=nil;len:=nil;
end;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function tarb.matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var alti,leni:tinteger;
begin
if wasfence or wasabort then result:=false
else begin
 alti:=alt as tinteger;
 leni:=len as tinteger;
 result:=(apos+i+alti.x+arlen<=length(astr));
 if result then begin
  inc(alti.x);inc(leni.x);
  if v<>nil then v^:=system.copy(astr,apos+1,leni.x);
 end;
 if debug1 then trace(result,'next',astr,apos,alt,len);
end; 
end;

function arb(ai:integer):tarb;overload;
begin
result:=tarb.create(ai);
end;
function arb:tarb;overload;
begin
result:=tarb.create(0);
end;
function arb(ai:integer;var s:string):tarb;overload;
begin
result:=tarb.create(ai,s);
end;
function arb(var s:string):tarb;overload;
begin
result:=tarb.create(0,s);
end;

constructor tpref.create(apatf:tpatfunction);
begin
inherited create;
patf:=apatf;
end;
constructor tpref.create(apatf:tpatfunction;apar:pointer);
begin
create(apatf);
setlength(par,1);
par[0]:=apar;
end;
constructor tpref.create(apatf:tpatfunction;apar:array of const);
var i,n:integer;
begin
create(apatf);
n:=high(apar)+1;
setlength(par,n);
for i:=0 to n-1 do par[i]:=apar[i].vpointer;
end;
constructor tpref.create(apatf:tpatfunction;var s:string);
begin
create(apatf);
v:=@s;
end;
constructor tpref.create(apatf:tpatfunction;apar:array of const;var s:string);
begin
create(apatf,apar);
v:=@s;
end;
constructor tpref.create(apatf:tpatfunction;apar:pointer;var s:string);
begin
create(apatf,apar);
v:=@s;
end;
function tpref.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var pat:tpattern;
begin
pat:=patf(par);
result:=pat.matchfirst(astr,apos,arlen,alt,len);
if result and (v<>nil) then v^:=system.copy(astr,apos+1,laenge(len));
end;
function tpref.matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var pat:tpattern;
begin
if wasfence or wasabort then begin
 result:=false;exit;
end; 
pat:=patf(par);
result:=pat.matchnext(astr,apos,arlen,alt,len);
if result and (v<>nil) then v^:=system.copy(astr,apos+1,laenge(len));
end;
function pref(apatf:tpatfunction):tpref;
begin
result:=tpref.create(apatf);
end;
function pref(apatf:tpatfunction;apar:pointer):tpref;
begin
result:=tpref.create(apatf,apar);
end;
function pref(apatf:tpatfunction;apar:array of const):tpref;
begin
result:=tpref.create(apatf,apar);
end;
function pref(apatf:tpatfunction;var s:string):tpref;
begin
result:=tpref.create(apatf,s);
end;
function pref(apatf:tpatfunction;apar:pointer;var s:string):tpref;
begin
result:=tpref.create(apatf,apar,s);
end;
function pref(apatf:tpatfunction;apar:array of const;var s:string):tpref;
begin
result:=tpref.create(apatf,apar,s);
end;

procedure makeklammer(var klaauf,klazu:tstringlist;klastr:string);
// Aus dem String klastr werden die Klammerlisten klaauf,klazu gemacht
var i,l:integer;
 sl:tstringlist;
 trenner:char;
begin
if klastr=''then begin
 klaauf:=nil;klazu:=nil;
end else begin
 klaauf:=tstringlist.Create;
 klazu:=tstringlist.Create;
 sl:=tstringlist.Create;
 if length(klastr)=1 then sl.add(klastr)
 else begin
  trenner:=klastr[1];system.delete(klastr,1,1);
  i:=system.pos(trenner,klastr);
  while i>0 do begin
   sl.add(system.copy(klastr,1,i-1));
   system.delete(klastr,1,i);
   i:=system.pos(trenner,klastr);
  end;
  if klastr<>''then sl.add(klastr);
 end;
 l:=sl.count;
 for i:=1 to l div 2 do begin
  klaauf.add(sl[2*i-2]);
  klazu.add(sl[2*i-1]);
 end;
 if odd(l)then begin
  klaauf.Add(sl[l-1]);
  klazu.Add(sl[l-1]);
 end;
end;
end;

procedure makeklammerlisten(var klaauf,klazu:tlist;klastr:string);
// Aus dem String klastr werden die Klammerlisten klaauf,klazu gemacht
var i,l:integer;
 sl:tstringlist;
 trenner:char;
begin
if klastr=''then begin
 klaauf:=nil;klazu:=nil;
end else begin
 trenner:=klastr[1];system.delete(klastr,1,1);
 klaauf:=tlist.Create;
 klazu:=tlist.Create;
 sl:=tstringlist.Create;
 i:=system.pos(trenner,klastr);
 while i>0 do begin
  sl.add(system.copy(klastr,1,i-1));
  system.delete(klastr,1,i);
  i:=system.pos(trenner,klastr);
 end;
 if klastr<>''then sl.add(klastr);
 l:=sl.count;
 for i:=1 to l div 2 do begin
  klaauf.add(tstring.create(sl[2*i-2]));
  klazu.add(tstring.create(sl[2*i-1]));
 end;
 if odd(l)then begin
  klaauf.Add(tstring.create(sl[l-1]));
  klazu.Add(tstring.create(sl[l-1]));
 end;
end;
end;

constructor tbal.create(const klastr,quotestr:string;aslash:char);
begin
inherited create;
makeklammerlisten(klaauf,klazu,klastr);
makeklammerlisten(quoteauf,quotezu,quotestr);
slash:=aslash;
end;
constructor tbal.create(const klastr,quotestr:string;aslash:char;var s:string);
begin
create(klastr,quotestr,aslash);
v:=@s;
end;
constructor tbal.create(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char);
begin
inherited create;
klaauf:=arr2list(aklaauf);klazu:=arr2list(aklazu);
quoteauf:=arr2list(aquoteauf);quotezu:=arr2list(aquotezu);
slash:=aslash;
end;
constructor tbal.create(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string);
begin
create(aklaauf,aklazu,aquoteauf,aquotezu,aslash);
v:=@s;
end;
function tbal.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var stack:tlist;
 s2,s3:string;
 j,ipos,iendpos:integer;
 l2,l3:tobject;
 auf:boolean;
 auflen,zulen:integer;
function isklaauf:boolean;
var j:integer;
begin
result:=false;
for j:=0 to klaauf.count-1 do begin
 l2:=klaauf[j];
 if l2 is tstring then begin
  s2:=(l2 as tstring).s;
  if isatpos(s2,astr,ipos+1)then begin
   result:=true;auflen:=length(s2);
  end;
 end else begin
  if mat0(astr,ipos,l2,auflen)then begin
   result:=true;
  end;
 end;
 if result then begin // klaauf
  ipos:=ipos+auflen;
  l3:=klazu[j];
  stack.add(l3);
  exit;
 end;
end;
end;
function isklazu:boolean;
var j:integer;
begin
result:=false;
for j:=0 to klazu.Count-1 do begin
 l2:=klazu[j];
 if l2 is tstring then begin
  s2:=(l2 as tstring).s;
  if isatpos(s2,astr,ipos+1)then begin
   result:=true;zulen:=length(s2);
  end;
 end else begin
  if mat0(astr,ipos,l2,zulen)then result:=true;
 end;
end;
end;
label 1,fehler;
begin
result:=(apos+arlen<=length(astr));
if not result then exit;
stack:=tlist.create;
ipos:=apos;
if isklaauf then begin
 if ipos+arlen>length(astr)then goto fehler;
 while ipos<length(astr) do begin
  if (slash<>#0)and(astr[ipos+1]=slash)then begin
   inc(ipos,2);goto 1;
  end;
  if quoteauf<>nil then begin
   auf:=false;
   for j:=0 to quoteauf.count-1 do begin
    l2:=quoteauf[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then begin
      auf:=true;auflen:=length(s2);
     end;
    end else begin
     if mat0(astr,ipos,l2,auflen)then begin
      auf:=true;
     end;
    end;
    if auf then begin // in quote ende suchen
     iendpos:=ipos+auflen;
     l3:=quotezu[j];
     if l3 is tstring then begin
      s3:=(l2 as tstring).s;
      while iendpos<=length(astr) do begin
       if isatpos(s3,astr,iendpos+1)then begin  // ende quote
        ipos:=iendpos+length(s3);goto 1;
       end else inc(iendpos,1);
      end;
      goto fehler;
     end{quotezu string} else begin
      // quotezu list oder pattern
      while iendpos<=length(astr) do begin
       if mat0(astr,iendpos,l3,zulen)then begin  // ende quote
        ipos:=iendpos+zulen;goto 1;
       end else inc(iendpos,1);
      end;
      goto fehler;
     end;
    end;
   end;
   for j:=0 to quotezu.Count-1 do begin
    l2:=quotezu[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then goto fehler; // quote ende gefunden
    end else begin
     if mat0(astr,ipos,l2,zulen)then goto fehler; // quote ende gefunden
    end;
   end;
  end;
  if isklaauf then goto 1;
  if isklazu then begin
   if (stack.count>0)and(stack[stack.Count-1]=l2) then begin
    inc(ipos,zulen);
    stack.delete(stack.count-1);
    goto 1;
   end else goto fehler;
  end;
  inc(ipos);
  1:
  if stack.count=0 then break;
 end;
 result:=stack.count=0;
 //stack.Free;
end else result:=false;
if result then begin
 len:=tinteger.create(ipos-apos);
 if v<>nil then v^:=system.copy(astr,apos+1,ipos-apos);
end else begin
 fehler:
 result:=false;
 len:=nil;
end;
alt:=nil;
if debug1 then trace(result,'first',astr,apos,nil,nil);
end;
function bal(const klastr:string):tbal;overload;
begin
result:=tbal.create(klastr,'',#0);
end;
function bal(const klastr:string;var s:string):tbal;overload;
begin
result:=tbal.create(klastr,'',#0,s);
end;
function quote(const quotestr:string):tbal;overload;
begin
result:=tbal.create('',quotestr,#0);
end;
function quote(const quotestr:string;var s:string):tbal;overload;
begin
result:=tbal.create('',quotestr,#0,s);
end;
{}
function balquote(const klastr,quotestr:string):tbal;overload;
begin
result:=tbal.create(klastr,quotestr,#0);
end;
function balquote(const klastr,quotestr:string;var s:string):tbal;overload;
begin
result:=tbal.create(klastr,quotestr,#0,s);
end;
{}
function balquote(const klastr,quotestr:string;aslash:char):tbal;overload;
begin
result:=tbal.create(klastr,quotestr,aslash);
end;
function balquote(const klastr,quotestr:string;aslash:char;var s:string):tbal;overload;
begin
result:=tbal.create(klastr,quotestr,aslash,s);
end;
function balquote(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char):tbal;overload;
begin
result:=tbal.create(aklaauf,aklazu,aquoteauf,aquotezu,aslash);
end;
function balquote(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string):tbal;overload;
begin
result:=tbal.create(aklaauf,aklazu,aquoteauf,aquotezu,aslash,s);
end;

constructor tsbal.create(const klastr,quotestr:string;aslash:char);
begin
inherited create;
makeklammerlisten(klaauf,klazu,klastr);
makeklammerlisten(quoteauf,quotezu,quotestr);
slash:=aslash;
end;
constructor tsbal.create(const klastr,quotestr:string;aslash:char;var s:string);
begin
create(klastr,quotestr,aslash);
v:=@s;
end;
constructor tsbal.create(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char);
begin
inherited create;
klaauf:=arr2list(aklaauf);klazu:=arr2list(aklazu);
quoteauf:=arr2list(aquoteauf);quotezu:=arr2list(aquotezu);
slash:=aslash;
end;
constructor tsbal.create(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string);
begin
create(aklaauf,aklazu,aquoteauf,aquotezu,aslash);
v:=@s;
end;
function tsbal.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
result:=(apos+arlen<=length(astr));
if result then begin
 alt:=tinteger.create(0);len:=tinteger.create(0);
 if v<>nil then v^:='';
end else begin
 alt:=nil;len:=nil;
end;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function tsbal.matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var stack:tlist;
 s2,s3:string;
 j,ipos,iendpos:integer;
 alti,leni:tinteger;
 l2,l3:tobject;
 auf,zu:boolean;
 auflen,zulen:integer;
label 1,fehler;
begin
//ss:=alt.classname;
alti:=alt as tinteger;
leni:=len as tinteger;
ipos:=apos+leni.x; // Anfang basis 0;
stack:=tlist.create;
if ipos>=length(astr)then result:=false
else if ipos+arlen>length(astr)then result:=false
else begin
 while ipos<length(astr) do begin
  if (slash<>#0)and(astr[ipos+1]=slash)then begin
   inc(ipos,2);goto 1;
  end;
  if quoteauf<>nil then begin
   auf:=false;
   for j:=0 to quoteauf.count-1 do begin
    l2:=quoteauf[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then begin
      auf:=true;auflen:=length(s2);
     end;
    end else begin
     if mat0(astr,ipos,l2,auflen)then auf:=true;
    end;
    if auf then begin // in quote ende suchen
     iendpos:=ipos+auflen;
     l3:=quotezu[j];
     if l3 is tstring then begin
      s3:=(l2 as tstring).s;
      while iendpos<=length(astr) do begin
       if isatpos(s3,astr,iendpos+1)then begin  // ende quote
        ipos:=iendpos+length(s3);goto 1;
       end else inc(iendpos,1);
      end;
      goto fehler;
     end{quotezu string} else begin
      // quotezu list oder pattern
      while iendpos<=length(astr) do begin
       if mat0(astr,iendpos,l3,zulen)then begin  // ende quote
        ipos:=iendpos+zulen;goto 1;
       end else inc(iendpos,1);
      end;
      goto fehler;
     end;
    end;
   end;
   for j:=0 to quotezu.Count-1 do begin
    l2:=quotezu[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then goto fehler; // quote ende gefunden
    end else begin
     if mat0(astr,ipos,l2,zulen)then goto fehler; // quote ende gefunden
    end;
   end;
  end;
  if klaauf<>nil then begin
   auf:=false;
   for j:=0 to klaauf.count-1 do begin
    l2:=klaauf[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then begin
      auf:=true;auflen:=length(s2);
     end;
    end else begin
     if mat0(astr,ipos,l2,auflen)then auf:=true;
    end;
    if auf then begin // klaauf
     ipos:=ipos+auflen;
     l3:=klazu[j];
     stack.add(l3);
     goto 1;
    end;
   end;
   zu:=false;
   for j:=0 to klazu.Count-1 do begin
    l2:=klazu[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then begin
      zu:=true;zulen:=length(s2);
     end;
    end else begin
     if mat0(astr,ipos,l2,zulen)then zu:=true;
    end;
    if zu then begin // klazu
     if (stack.count>0)and(stack[stack.Count-1]=l2) then begin
      inc(ipos,zulen);
      stack.delete(stack.count-1);
      goto 1;
     end else goto fehler;
    end;
   end;
  end;
  inc(ipos);
  1:
  if stack.count=0 then break;
 end;
 result:=stack.count=0;
 //stack.Free;
end;
if result then begin
 alti.x:=ipos-apos;leni.x:=ipos-apos;
 if v<>nil then v^:=system.copy(astr,apos+1,leni.x);
 //writeln('bal:[',system.copy(astr,apos+1,laenge(len)),']');
end else begin
 fehler:
 result:=false;alt:=nil;len:=nil;{stack.free;}
end;
if debug1 then trace(result,'next',astr,apos,alt,len);
end;

function sbal(const klastr:string):tsbal;overload;
begin
result:=tsbal.create(klastr,'',#0);
end;
function sbal(const klastr:string;var s:string):tsbal;overload;
begin
result:=tsbal.create(klastr,'',#0,s);
end;
function squote(const quotestr:string):tsbal;overload;
begin
result:=tsbal.create('',quotestr,#0);
end;
function squote(const quotestr:string;var s:string):tsbal;overload;
begin
result:=tsbal.create('',quotestr,#0,s);
end;
{
function sbalquote(const klastr,quotestr:string):tsbal;overload;
begin
result:=tsbal.create(klastr,quotestr,#0);
end;
function sbalquote(const klastr,quotestr:string;var s:string):tsbal;overload;
begin
result:=tsbal.create(klastr,quotestr,#0,s);
end;
}
function sbalquote(const klastr,quotestr:string;aslash:char):tsbal;overload;
begin
result:=tsbal.create(klastr,quotestr,aslash);
end;
function sbalquote(const klastr,quotestr:string;aslash:char;var s:string):tsbal;overload;
begin
result:=tsbal.create(klastr,quotestr,aslash,s);
end;
function sbalquote(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char):tsbal;overload;
begin
result:=tsbal.create(aklaauf,aklazu,aquoteauf,aquotezu,aslash);
end;
function sbalquote(aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string):tsbal;overload;
begin
result:=tsbal.create(aklaauf,aklazu,aquoteauf,aquotezu,aslash,s);
end;

constructor tnon.create(apat:tpattern);
begin
inherited create;
pat:=apat;
end;
constructor tnon.create(apat:array of const);
begin
inherited create;
pat:=tpat.create(apat);
end;
constructor tnon.create(astr:string);
begin
inherited create;
pat:=tstri.create(astr);
end;
function tnon.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var alt2,len2:tobject;
begin
result:=not pat.matchfirst(astr,apos,arlen,alt2,len2);
//alt2.free;len2.free;
alt:=nil;len:=nil;
end;
function non(apat:tpattern):tnon;overload;
begin
result:=tnon.create(apat);
end;
function non(apat:array of const):tnon;overload;
begin
result:=tnon.create(apat);
end;
function non(astr:string):tnon;overload;
begin
result:=tnon.create(astr);
end;

(*
type tlook=class(tpattern) // lookahes
public
 pat:tpattern; // pattern das gesucht wird
 lpat:tpattern; // lookahead pattern
 negativ:boolean; // wenn true lpat darf nicht folgen
 anchor:boolean; // das pattern pat muss nicht sofort kommen
 vbis:pstring;   // string bis zu beginn des pattern pat, wenn anchor=false;
*)
constructor tlook.create(alpat:tpattern);
begin
inherited create;
pat:=nil;
lpat:=alpat;
end;
constructor tlook.create(alpat:tpattern;var s:string);
begin
inherited create(s);
pat:=nil;
lpat:=alpat;
end;
constructor tlook.create(apat,alpat:tpattern;aanchor:boolean);
begin
create(alpat);
pat:=apat;
anchor:=aanchor;
end;
constructor tlook.create(apat:tpattern;alpat:tpattern;aanchor:boolean;var s:string);
begin
inherited create(s);
pat:=apat;lpat:=alpat;anchor:=aanchor;
end;
function tlook.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
// alt[0]= anzahl zeichen vor match
// alt[1]  alt von match
// len analog
var i,l,apos2,apos3,arlen2,arlen3:integer;
 alt2,len2,alt3,len3:tobject;
 altl,lenl:tlist;
 ss,ss2:string;
begin
apos2:=apos;
arlen2:=arlen;
alt:=nil;len:=nil;
result:=false;
altl:=tlist.create;altl.add(tinteger.create(0));altl.add(nil);
lenl:=tlist.create;lenl.add(tinteger.create(0));lenl.add(nil);
if pat=nil then begin // lpat suchen
 for i:=apos to length(astr)-lpat.minlen do begin
  result:=lpat.matchfirst(astr,i,arlen2,alt3,len3);
  if result then break;
 end;
 if result then begin
  alt:=nil;len:=tinteger.create(i-apos);
 end;
end else begin
 i:=0;
 result:=false;
 while true do begin
  result:=pat.matchfirst(astr,apos2,arlen2,alt2,len2);
  if result then begin
   l:=laenge(len2);
   apos3:=apos2+l;
   arlen3:=arlen2-lpat.minlen;
   if arlen3<0 then arlen3:=0;
   result:=lpat.matchfirst(astr,apos3,arlen3,alt3,len3);
   if result then begin
    tinteger(altl[0]).x:=i;
    tinteger(lenl[0]).x:=i;
    //tobject(altl[1]).free;
    altl[1]:=alt2;
    //tobject(lenl[1]).free;
    lenl[1]:=len2;
   end;
  end;
  if anchor or result then break;
  i:=i+1;
  apos2:=apos2+1;
 end;
 if result then begin
  alt:=altl;len:=lenl;
 end;
end;
if result then begin
 ss:=astr;
 if (v<>nil)then begin
  ss2:=system.copy(ss,apos+1,apos2-apos);
  v^:=ss2;
 end;
end;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function look(alpat:tpattern):tlook;overload;
begin
result:=tlook.create(alpat);
end;
function look(alpat:tpattern;var s:string):tlook;overload;
begin
result:=tlook.create(alpat,s);
end;
function look(apat,alpat:tpattern;aanchor:boolean):tlook;overload;
begin
result:=tlook.create(apat,alpat,aanchor);
end;
function look(apat:tpattern;alpat:tpattern;aanchor:boolean;var s:string):tlook;overload;
begin
result:=tlook.create(apat,alpat,aanchor,s);
end;

constructor tfind.create(apat:tpattern);
begin
inherited create;
pat:=apat;
klaauf:=nil;klazu:=nil;quoteauf:=nil;quotezu:=nil;
slash:=#0;
v:=nil;
end;
constructor tfind.create(apat:tpattern;var s:string);
begin
create(apat);
v:=@s;
end;
constructor tfind.create(apat:tpattern;const klastr:string;const quotestr:string;aslash:char);
// Beispiel:create(';(;);[;];{;}') liefert Klammerpaare () [] und {}
begin
create(apat);
makeklammerlisten(klaauf,klazu,klastr);
makeklammerlisten(quoteauf,quotezu,quotestr);
slash:=aslash;
end;
constructor tfind.create(apat:tpattern;const klastr,quotestr:string;aslash:char;var s:string);
begin
create(apat,klastr,quotestr,aslash);
v:=@s;
end;
constructor tfind.create(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char);
begin
create(apat);
klaauf:=arr2list(aklaauf);klazu:=arr2list(aklazu);
quoteauf:=arr2list(aquoteauf);quotezu:=arr2list(aquotezu);
slash:=aslash;
end;
constructor tfind.create(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string);
begin
create(apat,aklaauf,aklazu,aquoteauf,aquotezu,aslash);
v:=@s;
end;
function tfind.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var ipos,j,iendpos:integer;
 stack:tlist;
 s2,s3:string;
 alt2,len2:tobject;
 auf,zu:boolean;
 l2,l3:tobject;
 auflen,zulen:integer;
label 1,2,10,99,fehler;
begin
alt:=nil;len:=nil;
stack:=tlist.create;
if apos+arlen>length(astr)then
goto fehler
else begin
 ipos:=apos; // Basis 0
 matanzahl:=0;
 while ipos+arlen<=length(astr) do begin
  inc(matanzahl);
  if stack=nil then
  stack:=stack;
  if firstanzahl>=22 then
  firstanzahl:=firstanzahl;
  if stack.count=0 then begin
   // An dieser Stelle kann pat kommen
   {
   if (pram<>nil)and(length(pram^)>1000) then
   ipos:=ipos;
   }
   if (firstanzahl>=896) then
   firstanzahl:=firstanzahl;
   if pat.matchfirst(astr,ipos,0,alt2,len2)then begin
    2:
    result:=true;
    len:=tinteger.create(ipos-apos);
    if v<>nil then v^:=system.copy(astr,apos+1,ipos-apos);
    goto 99;
   end;
  end;
  if (slash<>#0)and(astr[ipos+1]=slash)then begin
   inc(ipos,2);goto 1;
  end;
  if quoteauf<>nil then begin
   auf:=false;
   for j:=0 to quoteauf.count-1 do begin
    l2:=quoteauf[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then begin
      auf:=true;auflen:=length(s2);
     end;
    end else begin
     if mat0(astr,ipos,l2,auflen)then auf:=true;
    end;
    if auf then begin // in quote ende suchen
     iendpos:=ipos+auflen;
     l3:=quotezu[j];
     if l3 is tstring then begin
      s3:=(l3 as tstring).s;
      while iendpos<=length(astr) do begin
       if isatpos(s3,astr,iendpos+1)then begin  // ende quote
        ipos:=iendpos+length(s3);goto 1;
       end else inc(iendpos,1);
      end;
      goto 10;
     end{quotezu string} else begin
      // quotezu list oder pattern
      while iendpos<=length(astr) do begin
       if mat0(astr,iendpos,l3,zulen)then begin  // ende quote
        ipos:=iendpos+zulen;goto 1;
       end else inc(iendpos,1);
      end;
      goto 10;
     end;
    end;
   end;
   for j:=0 to quotezu.Count-1 do begin
    l2:=quotezu[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then goto fehler; // quote ende gefunden
    end else begin
     if mat0(astr,ipos,l2,zulen)then goto fehler; // quote ende gefunden
    end;
   end;
  end;
  if klaauf<>nil then begin
   auf:=false;
   for j:=0 to klaauf.count-1 do begin
    l2:=klaauf[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then begin
      auf:=true;auflen:=length(s2);
     end;
    end else begin
     if mat0(astr,ipos,l2,auflen)then auf:=true;
    end;
    if auf then begin // klaauf
     ipos:=ipos+auflen;
     l3:=klazu[j];
     stack.add(l3);
     goto 1;
    end;
   end;
   zu:=false;
   for j:=0 to klazu.Count-1 do begin
    l2:=klazu[j];
    if l2 is tstring then begin
     s2:=(l2 as tstring).s;
     if isatpos(s2,astr,ipos+1)then begin
      zu:=true;zulen:=length(s2);
     end;
    end else begin
     if mat0(astr,ipos,l2,zulen)then zu:=true;
    end;
    if zu then begin // klazu
     if (stack.count>0)and(stack[stack.Count-1]=l2) then begin
      inc(ipos,zulen);
      stack.delete(stack.count-1);
      goto 1;
     end else goto fehler;
    end;
   end;
  end;
  10:
  inc(ipos); //weder slash noch quote noch klaauf noch klazu
  1:
 end;
 fehler:
 result:=false;
end;
99:
stack.Free;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function find(apat:tpattern):tfind;
begin
result:=tfind.create(apat);
end;
function find(apat:tpattern;var s:string):tfind;
begin
result:=tfind.create(apat,s);
end;
function find(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char):tfind;
begin
result:=tfind.create(apat,aklaauf,aklazu,aquoteauf,aquotezu,aslash);
end;
function find(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s:string):tfind;overload;
begin
result:=tfind.create(apat,aklaauf,aklazu,aquoteauf,aquotezu,aslash,s);
end;
function findb(apat:tpattern;const klastr:string):tfind;
// Beispiel:find('([{}])') liefert Klammerpaare () [] und {}
begin
result:=tfind.create(apat,klastr,'',#0);
end;
function findb(apat:tpattern;const klastr:string;var s:string):tfind;
begin
result:=tfind.create(apat,klastr,'',#0,s);
end;
function findq(apat:tpattern;const quotestr:string):tfind;
begin
result:=tfind.create(apat,'',quotestr,#0);
end;
{
function findq(apat:tpattern;const quotestr:string;var s:string):tfind;
begin
result:=tfind.create(apat,'',quotestr,#0,s);
end;
}
function findq(apat:tpattern;const quotestr:string;aslash:char):tfind;
begin
result:=tfind.create(apat,'',quotestr,aslash);
end;
function findq(apat:tpattern;const quotestr:string;aslash:char;var s:string):tfind;
begin
result:=tfind.create(apat,'',quotestr,aslash,s);
end;
function findbq(apat:tpattern;const klastr,quotestr:string):tfind;
begin
result:=tfind.create(apat,klastr,quotestr,#0);
end;
{
function findbq(apat:tpattern;const klastr,quotestr:string;var s:string):tfind;
begin
result:=tfind.create(apat,klastr,quotestr,#0,s);
end;
}
function findbq(apat:tpattern;const klastr,quotestr:string;aslash:char):tfind;
begin
result:=tfind.create(apat,klastr,quotestr,aslash);
end;
function findbq(apat:tpattern;const klastr,quotestr:string;aslash:char;var s:string):tfind;
begin
result:=tfind.create(apat,klastr,quotestr,aslash,s);
end;
function find(const astr:string):tfind;
begin
result:=tfind.create(stri(astr));
end;
function find(const astr:string;var s:string):tfind;
begin
result:=tfind.create(stri(astr),s);
end;
function findb(const astr:string;const klastr:string):tfind;
// Beispiel:find('([{}])') liefert Klammerpaare () [] und {}
begin
result:=tfind.create(stri(astr),klastr,'',#0);
end;
function findb(const astr:string;const klastr:string;var s:string):tfind;
begin
result:=tfind.create(stri(astr),klastr,'',#0,s);
end;
function findq(const astr:string;const quotestr:string):tfind;
begin
result:=tfind.create(stri(astr),'',quotestr,#0);
end;
{
function findq(const astr:string;const quotestr:string;var s:string):tfind;
begin
result:=tfind.create(stri(astr),'',quotestr,#0,s);
end;
}
function findq(const astr:string;const quotestr:string;aslash:char):tfind;
begin
result:=tfind.create(stri(astr),'',quotestr,aslash);
end;
function findq(const astr:string;const quotestr:string;aslash:char;var s:string):tfind;
begin
result:=tfind.create(stri(astr),'',quotestr,aslash,s);
end;
function findbq(const astr:string;const klastr,quotestr:string):tfind;
begin
result:=tfind.create(stri(astr),klastr,quotestr,#0);
end;
{
function findbq(const astr:string;const klastr,quotestr:string;var s:string):tfind;
begin
result:=tfind.create(stri(astr),klastr,quotestr,#0,s);
end;
}
function findbq(const astr:string;const klastr,quotestr:string;aslash:char):tfind;
begin
result:=tfind.create(stri(astr),klastr,quotestr,aslash);
end;
function findbq(const astr:string;const klastr,quotestr:string;aslash:char;var s:string):tfind;
begin
result:=tfind.create(stri(astr),klastr,quotestr,aslash,s);
end;

constructor tfindwith.create(apat:tpattern);
begin
inherited create;
pat:=apat;
klaauf:=nil;klazu:=nil;quoteauf:=nil;quotezu:=nil;
slash:=#0;
end;
constructor tfindwith.create(apat:tpattern;var s,spat:string);
// constructor create(apat:tpattern;var s,spat:string);overload;
begin
create(apat);
v:=@s;
vpat:=@spat;
end;
constructor tfindwith.create(apat:tpattern;const klastr:string;const quotestr:string;aslash:char);
// Beispiel:create(';(;);[;];{;}') liefert Klammerpaare () [] und {}
begin
create(apat);
makeklammerlisten(klaauf,klazu,klastr);
makeklammerlisten(quoteauf,quotezu,quotestr);
slash:=aslash;
end;
constructor tfindwith.create(apat:tpattern;const klastr,quotestr:string;aslash:char;var s,spat:string);
begin
create(apat,klastr,quotestr,aslash);
v:=@s;
vpat:=@spat;
end;
constructor tfindwith.create(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char);
begin
create(apat);
klaauf:=arr2list(aklaauf);klazu:=arr2list(aklazu);
quoteauf:=arr2list(aquoteauf);quotezu:=arr2list(aquotezu);
slash:=aslash;
end;
constructor tfindwith.create(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s,spat:string);
begin
create(apat,aklaauf,aklazu,aquoteauf,aquotezu,aslash);
v:=@s;
vpat:=@spat;
end;
//fehler
function tfindwith.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var lenbis:tobject;
 lbis,lpat:integer;
begin
if firstanzahl>=6173 then
firstanzahl:=firstanzahl;
result:=inherited matchfirst(astr,apos,arlen,alt,lenbis);
if result then begin
 lbis:=(lenbis as tinteger).x;
 mat0(astr,apos+lbis,pat,lpat);
 //lpat:=(lenpat as tinteger).x;
 len:=tinteger.create(lbis+lpat);
 if firstanzahl>=6173 then
 firstanzahl:=firstanzahl;
 if v<>nil then v^:=system.copy(astr,apos+1,lbis);
 if vpat<>nil then vpat^:=system.copy(astr,apos+lbis+1,lpat);
end;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
//function findwith(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s,spat:string):tfindwith;overload;
function findwith(apat:tpattern):tfindwith;
begin
result:=tfindwith.create(apat);
end;
function findwith(apat:tpattern;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(apat,s,spat);
end;
function findwith(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char):tfindwith;
begin
result:=tfindwith.create(apat,aklaauf,aklazu,aquoteauf,aquotezu,aslash);
end;
function findwith(apat:tpattern;aklaauf,aklazu,aquoteauf,aquotezu:array of const;aslash:char;var s,spat:string):tfindwith;overload;
begin
result:=tfindwith.create(apat,aklaauf,aklazu,aquoteauf,aquotezu,aslash,s,spat);
end;
function findwithb(apat:tpattern;const klastr:string):tfindwith;
// Beispiel:findwith('([{}])') liefert Klammerpaare () [] und {}
begin
result:=tfindwith.create(apat,klastr,'',#0);
end;
function findwithb(apat:tpattern;const klastr:string;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(apat,klastr,'',#0,s,spat);
end;
function findwithq(apat:tpattern;const quotestr:string):tfindwith;
begin
result:=tfindwith.create(apat,'',quotestr,#0);
end;
{
function findwithq(apat:tpattern;const quotestr:string;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(apat,'',quotestr,#0,s,spat);
end;
}
function findwithq(apat:tpattern;const quotestr:string;aslash:char):tfindwith;
begin
result:=tfindwith.create(apat,'',quotestr,aslash);
end;
function findwithq(apat:tpattern;const quotestr:string;aslash:char;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(apat,'',quotestr,aslash,s,spat);
end;
function findwithbq(apat:tpattern;const klastr,quotestr:string):tfindwith;
begin
result:=tfindwith.create(apat,klastr,quotestr,#0);
end;
{
function findwithbq(apat:tpattern;const klastr,quotestr:string;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(apat,klastr,quotestr,#0,s,spat);
end;
}
function findwithbq(apat:tpattern;const klastr,quotestr:string;aslash:char):tfindwith;
begin
result:=tfindwith.create(apat,klastr,quotestr,aslash);
end;
function findwithbq(apat:tpattern;const klastr,quotestr:string;aslash:char;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(apat,klastr,quotestr,aslash,s,spat);
end;
function findwith(const astr:string):tfindwith;
begin
result:=tfindwith.create(stri(astr));
end;
function findwith(const astr:string;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(stri(astr),s,spat);
end;
function findwithb(const astr:string;const klastr:string):tfindwith;
// Beispiel:findwith('([{}])') liefert Klammerpaare () [] und {}
begin
result:=tfindwith.create(stri(astr),klastr,'',#0);
end;
function findwithb(const astr:string;const klastr:string;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(stri(astr),klastr,'',#0,s,spat);
end;
function findwithq(const astr:string;const quotestr:string):tfindwith;
begin
result:=tfindwith.create(stri(astr),'',quotestr,#0);
end;
{
function findwithq(const astr:string;const quotestr:string;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(stri(astr),'',quotestr,#0,s,spat);
end;
}
function findwithq(const astr:string;const quotestr:string;aslash:char):tfindwith;
begin
result:=tfindwith.create(stri(astr),'',quotestr,aslash);
end;
function findwithq(const astr:string;const quotestr:string;aslash:char;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(stri(astr),'',quotestr,aslash,s,spat);
end;
function findwithbq(const astr:string;const klastr,quotestr:string):tfindwith;
begin
result:=tfindwith.create(stri(astr),klastr,quotestr,#0);
end;
{
function findwithbq(const astr:string;const klastr,quotestr:string;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(stri(astr),klastr,quotestr,#0,s,spat);
end;
}
function findwithbq(const astr:string;const klastr,quotestr:string;aslash:char):tfindwith;
begin
result:=tfindwith.create(stri(astr),klastr,quotestr,aslash);
end;
function findwithbq(const astr:string;const klastr,quotestr:string;aslash:char;var s,spat:string):tfindwith;
begin
result:=tfindwith.create(stri(astr),klastr,quotestr,aslash,s,spat);
end;

constructor trep.create(apat:tpattern;avon,abis:integer;agreedy:boolean);
begin
pat:=apat;von:=avon;bis:=abis;greedy:=agreedy;;
end;
constructor trep.create(apat:array of const;avon,abis:integer;agreedy:boolean);
begin
create(tpat.create(apat),avon,abis,agreedy);
end;
constructor trep.create(const s:string;avon,abis:integer;agreedy:boolean);
var pat:tpattern;
begin
inherited create;
pat:=tstri.create(s);
create(pat,avon,abis,agreedy);
end;
constructor trep.create(apat:tpattern;avon,abis:integer;agreedy:boolean;var s:string);
begin
create(apat,avon,abis,agreedy);
v:=@s;
end;
constructor trep.create(apat:array of const;avon,abis:integer;agreedy:boolean;var s:string);
begin
create(tpat.create(apat),avon,abis,agreedy,s);
end;
constructor trep.create(const ss:string;avon,abis:integer;agreedy:boolean;var s:string);
begin
create(ss,avon,abis,agreedy);
v:=@s;
end;
function trep.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var n,l,apos2:integer;
 alt2,len2:tobject;
 altl,lenl:tlist;
begin
n:=0;apos2:=apos;
alt:=nil;len:=nil;
if greedy then begin
 while ((n<bis)or(bis=0))and pat.matchfirst(astr,apos2,arlen,alt2,len2)do begin
  l:=laenge(len2);
  apos2:=apos2+l;
  alt2.free;len2.free;
  inc(n);
 end;
 result:=n>=von;
 if result then len:=tinteger.create(apos2-apos);
end else begin
 altl:=tlist.create;
 lenl:=tlist.create;
 while (n<von)and pat.matchfirst(astr,apos2,arlen,alt2,len2)do begin
  l:=laenge(len2);
  apos2:=apos2+l;
  altl.add(alt2);lenl.add(len2);
  inc(n);
 end;
 result:=n>=von;
 if result then begin
  alt:=altl;len:=lenl;
 end;
end;
if result then begin
 if(v<>nil)then v^:=system.copy(astr,apos+1,laenge(len));
end;
if debug1 then trace(result,'first',astr,apos,alt,len);
end;
function trep.matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var l,n,apos2,apos3,arlen2,arlen3,j,k,i:integer;
 len2,alt2:tobject;
 lenl,altl:tlist;
begin
if greedy or wasfence or wasabort then result:=false else begin
 altl:=alt as tlist;lenl:=len as tlist;
 n:=altl.count;
 apos2:=apos;arlen2:=arlen;
 for j:=n-1 downto 0 do begin
  result:=false;
  len2:=lenl[j];
  alt2:=altl[j];
  l:=laenge(len2);
  apos2:=apos2-l;arlen2:=arlen2+l;
  if pat.matchnext(astr,apos2,arlen2,alt2,len2)then begin
   result:=true;
   lenl[j]:=len2;
   altl[j]:=alt2;
   l:=laenge(len2);
   apos3:=apos2+l;arlen3:=arlen2-l;
   for i:=j+1 to n-1 do begin
    if pat.matchfirst(astr,apos3,arlen3,alt2,len2)then begin
     lenl.add(len2);
     altl.add(alt2);
     l:=laenge(len2);
     apos3:=apos3+l;arlen3:=arlen3-l;
    end else begin
     for k:=j+1 to i-1 do begin
      //tobject(lenl[k]).free;
      lenl[k]:=nil;
      //tobject(altl[k]).free;
      altl[k]:=nil;
     end;
     result:=false;break;
    end;
   end;
  end;
  if not result then begin
   //tobject(altl[j]).free;
   altl.count:=j;
   //tobject(lenl[j]).free;
   lenl.count:=j;
  end else exit;
 end;
 // Keine alternative mit n wiederholungen dann n+1 versuchen
 apos2:=apos;arlen2:=arlen;
 result:=false;
 if (bis<>0)and(n>=bis-1)then exit; //maximale Anzahl wiederholungen erreicht
 for i:=0 to n do begin
  if pat.matchfirst(astr,apos2,arlen2,alt2,len2)then begin
   lenl.add(len2);
   altl.add(alt2);
   l:=laenge(len2);
   apos2:=apos2+l;arlen2:=arlen2-l;
  end else exit;
 end;
 result:=true;
 if result then begin
  if(v<>nil)then v^:=system.copy(astr,apos+1,laenge(len));
 end;
end;
if debug1 then trace(result,'next',astr,apos,alt,len);
end;
function rep(apat:tpattern;avon,abis:integer;agreedy:boolean):trep;
begin
result:=trep.create(apat,avon,abis,agreedy);
end;
function rep(apat:array of const;avon,abis:integer;agreedy:boolean):trep;
begin
result:=trep.create(apat,avon,abis,agreedy);
end;
function rep(const s:string;avon,abis:integer;agreedy:boolean):trep;
begin
result:=trep.create(s,avon,abis,agreedy);
end;
function rep(apat:tpattern;avon,abis:integer;agreedy:boolean;var s:string):trep;
begin
result:=trep.create(apat,avon,abis,agreedy,s);
end;
function rep(apat:array of const;avon,abis:integer;agreedy:boolean;var s:string):trep;
begin
result:=trep.create(apat,avon,abis,agreedy,s);
end;
function rep(const ss:string;avon,abis:integer;agreedy:boolean;var s:string):trep;
begin
result:=trep.create(ss,avon,abis,agreedy,s);
end;
function rep(apat:tpattern;anzahl:integer):trep;
begin
result:=trep.create(apat,anzahl,anzahl,false);
end;
function rep(apat:tpattern;anzahl:integer;var s:string):trep;
begin
result:=trep.create(apat,anzahl,anzahl,false,s);
end;

function star(apa:tpattern):trep;overload;
begin
result:=rep(apa,0,0,greedyglb);
end;
function star(apa:array of const):trep;overload;
begin
result:=rep(apa,0,0,greedyglb);
end;
function star(const s:string):trep;overload;
begin
result:=rep(s,0,0,greedyglb);
end;
function star(apa:tpattern;var s:string):trep;overload;
begin
result:=rep(apa,0,0,greedyglb,s);
end;
function star(apa:array of const;var s:string):trep;overload;
begin
result:=rep(apa,0,0,greedyglb,s);
end;
function star(const ss:string;var s:string):trep;overload;
begin
result:=rep(ss,0,0,greedyglb,s);
end;

function star(apa:tpattern;agreedy:boolean):trep;overload;
begin
result:=rep(apa,0,0,agreedy);
end;
function star(apa:array of const;agreedy:boolean):trep;overload;
begin
result:=rep(apa,0,0,agreedy);
end;
function star(const s:string;agreedy:boolean):trep;overload;
begin
result:=rep(s,0,0,agreedy);
end;
function star(apa:tpattern;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(apa,0,0,agreedy,s);
end;
function star(apa:array of const;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(apa,0,0,agreedy,s);
end;
function star(const ss:string;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(ss,0,0,agreedy,s);
end;


function plus(apa:tpattern):trep;overload;
begin
result:=rep(apa,1,0,greedyglb);
end;
function plus(apa:array of const):trep;overload;
begin
result:=rep(apa,1,0,greedyglb);
end;
function plus(const s:string):trep;overload;
begin
result:=rep(s,1,0,greedyglb);
end;
function plus(apa:tpattern;var s:string):trep;overload;
begin
result:=rep(apa,1,0,greedyglb,s);
end;
function plus(apa:array of const;var s:string):trep;overload;
begin
result:=rep(apa,1,0,greedyglb,s);
end;
function plus(const ss:string;var s:string):trep;overload;
begin
result:=rep(ss,1,0,greedyglb,s);
end;

function plus(apa:tpattern;agreedy:boolean):trep;overload;
begin
result:=rep(apa,1,0,agreedy);
end;
function plus(apa:array of const;agreedy:boolean):trep;overload;
begin
result:=rep(apa,1,0,agreedy);
end;
function plus(const s:string;agreedy:boolean):trep;overload;
begin
result:=rep(s,1,0,agreedy);
end;
function plus(apa:tpattern;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(apa,1,0,agreedy,s);
end;
function plus(apa:array of const;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(apa,1,0,agreedy,s);
end;
function plus(const ss:string;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(ss,1,0,agreedy,s);
end;

function opt(apa:tpattern):trep;overload;
begin
result:=rep(apa,0,1,greedyglb);
end;
function opt(apa:array of const):trep;overload;
begin
result:=rep(apa,0,1,greedyglb);
end;
function opt(const s:string):trep;overload;
begin
result:=rep(s,0,1,greedyglb);
end;
function opt(apa:tpattern;var s:string):trep;overload;
begin
result:=rep(apa,0,1,greedyglb,s);
end;
function opt(apa:array of const;var s:string):trep;overload;
begin
result:=rep(apa,0,1,greedyglb,s);
end;
function opt(const ss:string;var s:string):trep;overload;
begin
result:=rep(ss,0,1,greedyglb,s);
end;

function opt(apa:tpattern;agreedy:boolean):trep;overload;
begin
result:=rep(apa,0,1,agreedy);
end;
function opt(apa:array of const;agreedy:boolean):trep;overload;
begin
result:=rep(apa,0,1,agreedy);
end;
function opt(const s:string;agreedy:boolean):trep;overload;
begin
result:=rep(s,0,1,agreedy);
end;
function opt(apa:tpattern;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(apa,0,1,agreedy,s);
end;
function opt(apa:array of const;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(apa,0,1,agreedy,s);
end;
function opt(const ss:string;agreedy:boolean;var s:string):trep;overload;
begin
result:=rep(ss,0,1,agreedy,s);
end;

procedure addconst2list(const arrele:tvarrec;const list:tlist);
var pa:tpattern;
begin
pa:=nil;
with arrele do case vtype of
 vtinteger:if vinteger=0 then pa:=tarb.create(0) else pa:=tlen.create(vinteger);
 vtstring:pa:=tstri.create(vstring^);
 vtansistring:pa:=tstri.create(string(vansistring));
 vtobject:if vobject is tpattern then pa:=vobject as tpattern;
 vtchar:pa:=tstri.create(vchar);
end;
if pa<>nil then begin
 list.add(pa);
end;
end;

procedure arrconst2list(const arr:array of const;const list:tlist);
// Die elemente aus arr werden in pat angehangen
var i:integer;
begin
for i:=0 to high(arr) do begin
 addconst2list(arr[i],list);
end;
end;

procedure tpat.computeminrestlen;
var i:integer;
begin
minlen:=tpattern(pat.last).minlen;
minrestlen:=tintarray.create(pat.count);
minrestlen[minrestlen.count-1]:=0;
for i:=pat.count-2 downto 0 do begin
 minrestlen[i]:=minlen;
 minlen:=minlen+tpattern(pat[i]).minlen;
end;
end;
constructor tpat.create(apat:tpattern;var s:string);
begin
create([apat],s);
end;
constructor tpat.create(apat:tlist);
begin
pat:=apat;
computeminrestlen;
end;
constructor tpat.create(apat:tlist;var s:string);
begin
create(apat);v:=@s;
end;
constructor tpat.create(apat:array of const);
begin
inherited create;
pat:=tlist.create;
arrconst2list(apat,pat);
computeminrestlen;
end;
constructor tpat.create(apat:array of const;var s:string);
begin
create(apat);v:=@s;
end;
function tpat.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var apos2,i,j,k,arlen2:integer;
 pa,pa2:tpattern;
 len2,alt2:tobject;
 altl,lenl:tlist;
 ss:string;
begin
altl:=tlist.create;alt:=altl;
lenl:=tlist.create;len:=lenl;
result:=true;
i:=0;apos2:=apos;
while i<pat.count do begin
 if i=3 then
 i:=i;
 pa:=tobject(pat[i])as tpattern;
 arlen2:=minrestlen[i];
 if pa is tfind then
 pa:=pa;
 inc(firstanzahl);
 if firstanzahl>=4 then
 firstanzahl:=firstanzahl;
 if pa.matchfirst(astr,apos2,arlen2,alt2,len2)then begin
  if (matanzahl=2)and(firstanzahl=4) then
  matanzahl:=matanzahl;
  altl.add(alt2);
  lenl.add(len2);
  if debug1 then tracepat('first',i,astr,apos2,alt2,len2);
  apos2:=apos2+laenge(len2);
  inc(i);
 end else begin // alternative
  result:=false;
  if wasabort or wasfence then begin
   for j:=i-1 downto 0 do begin
    //tobject(altl[j]).free;
    //tobject(lenl[j]).free;
   end;
   //altl.free;
   //lenl.free;
   alt:=nil;len:=nil;
   break;
  end;
  for j:=i-1 downto 0 do begin
   // bei den vorigen eine alternative
   pa2:=tobject(pat[j]) as tpattern;
   ss:=pa2.classname;
   len2:=lenl[j];
   alt2:=altl[j];
   apos2:=apos2-laenge(len2);
   if pa2 is tfence then begin
    for k:=j downto 0 do begin
     //tobject(altl[k]).free;
     //tobject(lenl[k]).free;
    end;
    //altl.Free;
    //lenl.free;
    alt:=nil;
    len:=nil;
    wasfence:=true;
    break;
   end;
   if pa2.matchnext(astr,apos2,minrestlen[j],alt2,len2)then begin
    lenl[j]:=len2;
    altl[j]:=alt2;
    if debug1 then tracepat('first back',j,astr,apos2,alt2,len2);
    //if debug then writeln('tpat retry:',j,' [',system.copy(astr,apos2+1,laenge(len2)),']');
    apos2:=apos2+laenge(len2);
    i:=j+1;
    result:=true;break;
   end else begin
    //tobject(altl[j]).free;
    altl.count:=j;
    //tobject(lenl[j]).free;
    lenl.count:=j;
   end;
  end;
 end;
 if not result then break;
end;
if result then begin
 // iv besetzen
 if (v<>nil)then v^:=system.copy(astr,apos+1,laenge(len));
end;
if debug1 then trace(result,'first total',astr,apos,alt,len);
end;
function tpat.matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var apos2,i,j,k:integer;
 pa,pa2:tpattern;
 altl,lenl:tlist;
 len2,alt2:tobject;
begin
result:=false;
if wasfence or wasabort then exit;
altl:=alt as tlist;
lenl:=len as tlist;
apos2:=apos+laenge(lenl);
i:=pat.count;
for j:=pat.count-1 downto 0 do begin
 pa2:=tobject(tobject(pat[j])) as tpattern;
 len2:=lenl[j];
 alt2:=altl[j];
 apos2:=apos2-laenge(len2);
 if pa2.matchnext(astr,apos2,minrestlen[j],alt2,len2)then begin
  lenl[j]:=len2;
  altl[j]:=alt2;
  if debug1 then tracepat('next',i,astr,apos2,alt2,len2);
  apos2:=apos2+laenge(len2);
  i:=j+1;
  result:=true;break;
 end else begin
  if pa2 is tfence then begin
   for k:=j-1 downto 0 do begin
    //tobject(altl[k]).free;
    //tobject(lenl[k]).free;
   end;
   //altl.free;
   //lenl.free;
   alt:=nil;len:=nil;
   wasfence:=true;
   break;
  end;
  //tobject(altl[j]).free;
  altl.count:=j+1;
  //tobject(lenl[j]).free;
  lenl.count:=j+1;
 end;
end;
if not result then begin
 alt:=nil;len:=nil;exit;  //keine Alternative
end;
// von der neuen alternative an die restlichen versuchen
while i<pat.count do begin
 pa:=tobject(pat[i])as tpattern;
 if pa.matchfirst(astr,apos2,minrestlen[i],alt2,len2)then begin
  altl.add(alt2);
  lenl.add(len2);
  if debug1 then tracepat('next',i,astr,apos2,alt2,len2);
  apos2:=apos2+laenge(len2);
  inc(i);
 end else begin // alternative
  result:=false;
  if wasabort then begin
   for j:=i-1 downto 0 do begin
    //tobject(altl[j]).free;
    //tobject(lenl[j]).free;
   end;
   //altl.free;
   //lenl.free;
   alt:=nil;len:=nil;
   break;
  end;
  for j:=i-1 downto 0 do begin
   pa2:=tobject(tobject(pat[j])) as tpattern;
   len2:=lenl[j];
   alt2:=altl[j];
   apos2:=apos2-laenge(len2);
   if pa2.matchnext(astr,apos2,minrestlen[j],alt2,len2)then begin
    lenl[j]:=len2;
    altl[j]:=alt2;
    if debug1 then tracepat('next back',i,astr,apos2,alt2,len2);
    apos2:=apos2+laenge(len2);
    i:=j+1;
    result:=true;break;
   end else begin
    //tobject(altl[j]).free;
    altl.count:=j;
    //tobject(lenl[j]).free;
    lenl.count:=j;
   end;
  end;
 end;
 if not result then begin
  alt:=nil;len:=nil;break;
 end;
end;
if result then begin
 // iv besetzen
 if (v<>nil)then v^:=system.copy(astr,apos+1,laenge(len));
end;
if debug1 then trace(result,'next total',astr,apos,alt,len);
end;
procedure tpat.tracepat(kind:string;i:integer;const astr:string;apos:integer;alt,len:tobject);
begin
if debug2 then writetrace(classname+' '+kind+'('+strv(i)+'):'+system.copy(astr,1,apos)+
 tracestr[1]+system.copy(astr,apos+1,laenge(len))+tracestr[2]+system.copy(astr,apos+1+laenge(len),255))
else if debug1 then writetrace(classname+' '+kind+'('+strv(i)+'):'+tracestr[1]+system.copy(astr,apos+1,laenge(len))+tracestr[2]);
end;

function pat(apat:tpattern;var s:string):tpat;overload;
begin
result:=tpat.create(apat,s);
end;
function pat(apat:array of const):tpat;overload;
begin
result:=tpat.create(apat);
end;
function pat(apat:array of const;var s:string):tpat;overload;
begin
result:=tpat.create(apat,s);
end;
function pat(astr:string):tstri;overload;
begin
result:=tstri.create(astr);
end;
function pat(ai:integer):tarb;overload;
begin
result:=tarb.create(ai);
end;
function pat(ai:integer;var s:string):tarb;overload;
begin
result:=tarb.create(ai,s);
end;

constructor talt.create(aalt:array of const);
var i:integer;
 pa:tpattern;
begin
inherited create;
alterl:=tlist.create;
minlen:=maxint;
for i:=0 to high(aalt) do begin
 pa:=nil;
 with aalt[i] do case vtype of
  vtinteger:if vinteger=0 then pa:=tarb.create(0) else pa:=tlen.create(vinteger);
  vtstring:pa:=tstri.create(vstring^);
  vtansistring:pa:=tstri.create(string(vansistring));
  vtobject:if vobject is tpattern then pa:=vobject as tpattern;
  vtchar:pa:=tstri.create(vchar);
 end;
 if pa<>nil then begin
  alterl.add(pa);
  if minlen>pa.minlen then minlen:=pa.minlen;
 end;
end;
end;
constructor talt.create(aalt:array of const;var s:string);
begin
create(aalt);v:=@s;
end;
function talt.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var i:integer;
 alt2:tobject;
 pa:tpattern;
 altl:tlist;
 //lenl:tlist;
 //l:integer;
 ss:string;
begin
result:=false;
alt:=nil;len:=nil;
for i:=0 to alterl.count-1 do begin
 pa:=tobject(alterl[i])as tpattern;
 ss:=pa.classname;
 result:=pa.matchfirst(astr,apos,arlen,alt2,len);
 if result then begin
  altl:=tlist.create;alt:=altl;
  altl.add(alt2);altl.add(tinteger.create(i));
  //l:=laenge(len);
  if debug1 then tracealt('first',i,astr,apos,alt,len);
  break;
 end else if wasabort or wasfence then begin
  alt:=nil;len:=nil;
  break;
 end;
end;
if result and (v<>nil)then v^:=system.copy(astr,apos+1,laenge(len));
end;
function talt.matchnext(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var pa:tpattern;
 i:integer;
 alt2:tobject;
 altl:tlist;
begin
result:=false;
if wasfence or wasabort then exit;
altl:=alt as tlist;
i:=tinteger(altl[1]).x;
pa:=tobject(alterl[i])as tpattern;
alt2:=altl[0];
result:=pa.matchnext(astr,apos,arlen,alt2,len);
if result then begin
 altl[0]:=alt2;
 if debug1 then tracealt('next',i,astr,apos,alt,len);
end else begin
 // die restlichen alternativen testen
 for i:=i+1 to alterl.count-1 do begin
  pa:=tobject(alterl[i])as tpattern;
  result:=pa.matchfirst(astr,apos,arlen,alt2,len);
  if wasfence or wasabort then exit;
  if result then begin
   altl[0]:=alt2;tinteger(altl[1]).x:=i;
   if debug1 then tracealt('next',i,astr,apos,alt,len);
   break;
  end;
 end;
end;
if result and (v<>nil)then v^:=system.copy(astr,apos+1,laenge(len));
end;
procedure talt.tracealt(kind:string;i:integer;const astr:string;apos:integer;alt,len:tobject);
begin
if debug2 then writetrace(classname+' '+kind+'('+strv(i)+'):'+system.copy(astr,1,apos)+
 tracestr[1]+system.copy(astr,apos+1,laenge(len))+tracestr[2]+system.copy(astr,apos+1+laenge(len),255))
else if debug1 then writetrace(classname+' '+kind+'('+strv(i)+'):'+tracestr[1]+system.copy(astr,apos+1,laenge(len))+tracestr[2]);
end;
function alt(aalt:array of const):talt;overload;
begin
result:=talt.create(aalt);
end;
function alt(aalt:array of const;var s:string):talt;overload;
begin
result:=talt.create(aalt,s);
end;

constructor tcurs.create(var apos:integer);
begin
inherited create;
posref:=@apos;
end;
function tcurs.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
result:=true;
posref^:=apos;
alt:=nil;len:=nil;
if debug1 then trace(result,'',astr,apos,alt,len);
end;
function curs(var apos:integer):tcurs;
begin
result:=tcurs.create(apos);
end;

constructor tlpos.create(aposi:integer);
begin
inherited create;
posi:=aposi;vv:=nil;
end;
constructor tlpos.create(av:tiv);
begin
vv:=av;
end;
function tlpos.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
if vv<>nil then posi:=vv.compute;
alt:=nil;
if apos=posi then begin
 result:=true;len:=tinteger.create(0);
end else begin
 len:=nil;result:=false;
end;
if debug1 then trace(result,'',astr,apos,alt,len);
end;
function lpos(aposi:integer):tlpos;
begin
result:=tlpos.create(aposi);
end;
function lpos(av:tiv):tlpos;
begin
result:=tlpos.create(av);
end;

constructor trpos.create(aposi:integer);
begin
inherited create;
posi:=aposi;
end;
constructor trpos.create(av:tiv);
begin
vv:=av;
end;
function trpos.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
if vv<>nil then posi:=vv.compute;
alt:=nil;
if length(astr)-posi=apos then begin
 result:=true;len:=tinteger.create(0);
end else begin
 len:=nil;result:=false;
end;
if debug1 then trace(result,'',astr,apos,alt,len);
end;
function rpos(aposi:integer):trpos;
begin
result:=trpos.create(aposi);
end;
function rpos(av:tiv):trpos;
begin
result:=trpos.create(av);
end;

constructor ttab.create(atabi:integer);
begin
inherited create;
tabi:=atabi;
vv:=nil;
end;
constructor ttab.create(atabi:integer;var s:string);
begin
create(atabi);v:=@s;
end;
constructor ttab.create(av:tiv);
begin
vv:=av;
end;
constructor ttab.create(av:tiv;var s:string);
begin
create(av);v:=@s;
end;
function ttab.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
if vv<>nil then tabi:=vv.compute;
alt:=nil;
if apos<=tabi then begin
 result:=true;len:=tinteger.create(tabi-apos);
end else begin
 len:=nil;result:=false;
end;
if result then begin
 if v<>nil then v^:=system.copy(astr,apos+1,tabi-apos);
end;
if debug1 then trace(result,'',astr,apos,alt,len);
end;
function tab(atabi:integer):ttab;
begin
result:=ttab.create(atabi);
end;
function tab(atabi:integer;var s:string):ttab;
begin
result:=ttab.create(atabi,s);
end;
function tab(av:tiv):ttab;
begin
result:=ttab.create(av);
end;
function tab(av:tiv;var s:string):ttab;
begin
result:=ttab.create(av,s);
end;

constructor trtab.create(atabi:integer);
begin
inherited create;
tabi:=atabi;
vv:=nil;
end;
constructor trtab.create(atabi:integer;var s:string);
begin
create(atabi);v:=@s;
end;
constructor trtab.create(av:tiv);
begin
vv:=av;
end;
constructor trtab.create(av:tiv;var s:string);
begin
create(av);v:=@s;
end;
function trtab.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var l:integer;
begin
if vv<>nil then tabi:=vv.compute;
l:=length(astr)-tabi-apos;
alt:=nil;
if l>=0 then begin
 result:=true;len:=tinteger.create(l);
end else begin
 len:=nil;result:=false;
end;
if result then begin
 if v<>nil then v^:=system.copy(astr,apos+1,l);
end;
if debug1 then trace(result,'',astr,apos,alt,len);
end;
function rtab(atabi:integer):trtab;
begin
result:=trtab.create(atabi);
end;
function rtab(atabi:integer;var s:string):trtab;
begin
result:=trtab.create(atabi,s);
end;
function rtab(av:tiv):trtab;
begin
result:=trtab.create(av);
end;
function rtab(av:tiv;var s:string):trtab;
begin
result:=trtab.create(av,s);
end;

function rem:trtab;
begin
result:=trtab.create(0);
end;
function rem(var s:string):trtab;
begin
result:=trtab.create(0,s);
end;

function tabort.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
result:=false;
wasabort:=true;
alt:=nil;len:=nil;
end;
function abort:tabort;
begin
result:=tabort.create;
end;

function tfail.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
result:=false;
alt:=nil;len:=nil;
end;
function fail:tfail;
begin
result:=tfail.create;
end;


function fence:tfence;
begin
result:=tfence.create;
end;

function tcrlf.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
alt:=nil;len:=nil;
result:=(apos+2+arlen<=length(astr))and (astr[apos+1]=#13)and(astr[apos+2]=#10);
if result then len:=tinteger.create(2)
else begin
 result:=(apos+1+arlen<=length(astr))and(astr[apos+1]in[#13,#10]);
 if result then len:=tinteger.create(1);
end;
end;
function crlf:tcrlf;
begin
result:=tcrlf.create;
end;

function twordstart.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
alt:=nil;len:=nil;
result:=apos+arlen<=length(astr);
if result then begin
 result:=(astr[apos+1]in namechars)and((apos=0)or (not (astr[apos]in namechars)));
 if result then begin
  len:=nil;
 end;
end;
if debug1 then trace(result,'',astr,apos,alt,len);
end;
function wordstart:twordstart;
begin
result:=twordstart.create;
end;

function twordend.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
begin
alt:=nil;len:=nil;
result:=(apos>0)and(apos+arlen<=length(astr));
if result then begin
 result:=(astr[apos]in namechars)and((apos=length(astr))or((not (astr[apos+1]in namechars))));
end;
if debug1 then trace(result,'',astr,apos,alt,len);
end;
function wordend:twordend;
begin
result:=twordend.create;
end;

constructor trepl.create(apat:tpattern;asub:tsv);
begin
inherited create;
pat:=apat;sub:=asub;
end;
function trepl.matchfirst(astr:string;apos,arlen:integer;var alt,len:tobject):Boolean;
var alt2,len2:tobject;
 l:integer;
 s2:string;
begin
result:=pat.matchfirst(astr,apos,arlen,alt2,len2);
if result then begin
 l:=laenge(len2);
 s2:=sub.compute;
 system.delete(astr,apos+1,l);
 system.insert(s2,astr,apos+1);
 alt:=nil;
 len:=tinteger.create(length(s2));
end;
end;
function repl(apat:array of const;asub:tsv):trepl;overload;
begin
result:=trepl.create(tpat.create(apat),asub);
end;
function repl(apat:tpattern;asub:tsv):trepl;overload;
begin
result:=trepl.create(apat,asub);
end;
function repl(apat:array of const;asub:array of const):trepl;overload;
begin
result:=trepl.create(tpat.create(apat),tcat.create(asub));
end;
function repl(apat:tpattern;asub:array of const):trepl;overload;
begin
result:=trepl.create(apat,tcat.create(asub));
end;
{mat}
function mat(s:string;ab:integer;const pat:tpattern;var apos,alen:integer):boolean;
overload;
//matcht s pat irgenwo ab ab wenn ja apos und alen setzen
// bei anchor=true muss ab ab gematcht werden
var alt,len:tobject;
 i,bis:integer;
// test:integer;
begin
result:=false;wasabort:=false;wasfence:=false;apos:=0;alen:=0;
if anchorglb then bis:=ab else bis:=length(s)-pat.minlen;
for i:=ab to bis do begin
 {
 if firstanzahl>=5887 then
 test:=test;
 }
 result:=pat.matchfirst(s,i,0,alt,len);
 if result then begin
  apos:=i;alen:=laenge(len);exit;
 end;
 if wasabort or wasfence then exit;
end;
end;
function mat(s:string;ab:integer;const pat:tpattern;var apos:integer;var s2:string):boolean;
overload;
// matcht s pat ab ab irgenwo, wenn ja apos Position und s2 gematchter string
var alen:integer;
begin
result:=mat(s,ab,pat,apos,alen);
if result then s2:=system.copy(s,apos+1,alen);
end;
function mat(s:string;ab:integer;const pat:tpattern;var s2:string):boolean;
overload;
// matcht s pat ab ab irgenwo, wenn ja s2 gematchter string
var apos:integer;
begin
result:=mat(s,ab,pat,apos,s2);
end;
function mat(s:string;ab:integer;const pat:tpattern):boolean;
overload;
// matcht in s pat ab ab irgenwo
var apos,alen:integer;
begin
result:=mat(s,ab,pat,apos,alen);
end;
function mat(s:string;ab:integer;par:array of const;var apos,alen:integer):boolean;
overload;
var pa:tpat;
begin
pa:=tpat.create(par);
result:=mat(s,ab,pa,apos,alen);
end;
function mat(s:string;ab:integer;par:array of const;var apos:integer;var s2:string):boolean;
overload;
var pa:tpat;
begin
pa:=tpat.create(par);
result:=mat(s,ab,pa,apos,s2);
end;
function mat(s:string;ab:integer;par:array of const;var s2:string):boolean;
overload;
var apos:integer;
begin
result:=mat(s,ab,par,apos,s2);
end;
function mat(s:string;ab:integer;par:array of const):boolean;
overload;
var apos,alen:integer;
begin
result:=mat(s,ab,par,apos,alen);
end;
function mat(s:string;ab:integer;const s2:string;var apos:integer):boolean;
// Match s2 in s ab ab
overload;
var alen:integer;
begin
result:=mat(s,ab,tstri.create(s2),apos,alen);
end;
function mat(s:string;const pat:tpattern;var apos,alen:integer):boolean;
overload;
// Test:matcht s pat irgenwo ab ab wenn ja apos und alen setzen
// bei anchor=true muss ab ab gematcht werden
begin
result:=mat(s,0,pat,apos,alen);
end;
function mat(s:string;const pat:tpattern;var apos:integer;var s2:string):boolean;
overload;
// Test:matcht s pat ab ab irgenwo, wenn ja apos Position und s2 gematchter string
begin
result:=mat(s,0,pat,apos,s2);
end;
function mat(s:string;const pat:tpattern;var s2:string):boolean;
overload;
// matcht s pat ab ab irgenwo, wenn ja s2 gematchter string
begin
result:=mat(s,0,pat,s2);
end;
function mat(s:string;const pat:tpattern):boolean;
overload;
begin
result:=mat(s,0,pat);
end;
function mat(s:string;par:array of const;var apos,alen:integer):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja apos Position und alen Lnge desgematchten String
begin
result:=mat(s,0,par,apos,alen);
end;
function mat(s:string;par:array of const;var apos:integer;var s2:string):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja apos Position und s2 gematchter string
begin
result:=mat(s,0,par,apos,s2);
end;
function mat(s:string;par:array of const;var s2:string):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo, wenn ja apos Position und s2 gematchter string
begin
result:=mat(s,0,par,s2);
end;
function mat(s:string;par:array of const):boolean;
overload;
// Test:matcht s die Patternfolge par ab ab irgenwo
begin
result:=mat(s,0,par);
end;
function mat(s:string;const s2:string;var apos:integer):boolean;
overload;
// Test:matcht s den String s2 ab ab irgenwo, wenn ja apos Position
begin
result:=mat(s,0,s2,apos);
end;
procedure snobolerror(s:string);
begin
writeln('Mysnobol:'+s);
readln;
halt;
end;
function mat0(s:string;ab:integer;pat:tobject;var alen:integer):boolean;
var alt,len:tobject;
 pa:tpattern;
begin

if pat is tstring then pa:=tstri.create((pat as tstring).s)
else if pat is tlist then pa:=tpat.create(pat as tlist)
else if pat is tpattern then pa:=pat as tpattern
else begin
 snobolerror('Systemfehler mat0');pa:=nil;
end;
result:=pa.matchfirst(s,ab,0,alt,len);
if result then alen:=laenge(len);
end;

function replace(const s:string;pat:tpattern;newstr:tstri;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;overload;
// s wird ab ab gematcht ;gematchter string beginn bei apos und hat Lnge alen
// er wird ersetzt durch substr
// Positionen beginn bei 0 !!
// Funktionswert: der neue string
//
var s1,s2:string;
 apos,alen:integer;
 anchorold:boolean;
begin
anchorold:=anchorglb;
anchorglb:=ancho;
s1:=s;
while mat(s1,ab,pat,apos,alen) do begin
 // Ersetzen
 s2:=newstr.compute;
 if rek then s2:=replace(s2,pat,newstr,rep,rek,ancho,1);
 system.delete(s1,apos+1,alen);
 system.insert(s2,s1,apos+1);
 if rep then begin
  ab:=apos+length(s2);
 end else break;
end;
result:=s1;
anchorglb:=anchorold;
end;
function replace(const s:string;arr:array of const;newstr:tstri;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;overload;
var pat:tpat;
begin
pat:=tpat.create(arr);
result:=replace(s,pat,newstr,rep,rek,ancho,ab);
end;
function replace(const s:string;pat:tpattern;newstr:string;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;
begin
result:=replace(s,pat,tstri.create(newstr),rep,rek,ancho,ab);
end;
function replace(const s:string;arr:array of const;newstr:string;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;
begin
result:=replace(s,arr,tstri.create(newstr),rep,rek,ancho,ab);
end;
function replace(const s:string;pat:tpattern;newstr:array of const;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;
var cat:tcat;
begin
cat:=tcat.create(newstr);
result:=replace(s,pat,cat,rep,rek,ancho,ab);
end;
function replace(const s:string;arr:array of const;newstr:array of const;
         rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0):string;
var pat:tpat;
 cat:tcat;
begin
pat:=tpat.create(arr);
cat:=tcat.create(newstr);
result:=replace(s,pat,cat,rep,rek,ancho,ab);
end;

function match(s:string;pat:tpattern;rep:boolean=false;rek:boolean=false;ancho:boolean=false;trenner:string='';ab:integer=0):string;overload;
var ipos,apos,alen:integer;
 s2,s3,s4:string;
begin
s2:='';
ipos:=ab;
while mat(s,ipos,pat,apos,alen)and(alen>0) do begin
 if s2<>''then s2:=s2+trenner;
 s3:=system.copy(s,apos+1,alen);
 s2:=s2+s3;
 if rek then begin
  s4:=match(s3,pat,rep,rek,ancho,trenner,1);
  if s4<>''then begin
   if s2<>''then s2:=s2+trenner;
   s2:=s2+s4;
  end;
 end;
 if not rep then break;
 ipos:=apos+alen;
end;
result:=s2;
end;

function match(s:string;arr:array of const;rep:boolean=false;rek:boolean=false;ancho:boolean=false;trenner:string='';ab:integer=0):string;overload;
var pat:tpat;
begin
pat:=tpat.create(arr);
result:=match(s,pat,rep,rek,ancho,trenner,ab);
end;

function matchall(s:string;ab:integer;pat:tpattern;var apos:arrayofinteger;var sl:arrayofstring):integer;
overload;
var i,l,pos2:integer;
 s2:string;
 apos2:tintarray;
 sl2:tstringlist;
begin
result:=0;
apos2:=tintarray.create;sl2:=tstringlist.create;
while mat(s,ab,pat,pos2,s2)do begin
 apos2.add(pos2);
 sl2.add(s2);
 inc(result);
 ab:=pos2+length(s2);
end;
l:=sl2.count;
setlength(apos,l);
setlength(sl,l);
for i:=0 to l-1 do begin
 apos[i]:=apos2[i];sl[i]:=sl2[i];
end;
end;
function matchall(s:string;ab:integer;pat:array of const;var apos:arrayofinteger;var sl:arrayofstring):integer;
overload;
var i,l,pos2:integer;
 s2:string;
 apos2:tintarray;
 sl2:tstringlist;
begin
apos2:=tintarray.create;sl2:=tstringlist.create;
result:=0;
while mat(s,ab,pat,pos2,s2)do begin
 apos2.add(pos2);
 sl2.add(s2);
 inc(result);
 ab:=pos2+length(s2);;
end;
l:=sl2.count;
setlength(apos,l);
setlength(sl,l);
for i:=0 to l-1 do begin
 apos[i]:=apos2[i];sl[i]:=sl2[i];
end;
end;
function matchall(s:string;ab:integer;pat:tpattern;var sl:arrayofstring):integer;
var apos:arrayofinteger;
begin
setlength(apos,0);
result:=matchall(s,ab,pat,apos,sl);
end;
function matchall(s:string;ab:integer;pat:array of const;var sl:arrayofstring):integer;
var apos:arrayofinteger;
begin
setlength(apos,0);
result:=matchall(s,ab,pat,apos,sl);
end;
function matchall(s:string;pat:tpattern;var apos:arrayofinteger;var sl:arrayofstring):integer;
// In s werden alle Teilstrings, die pat matchen ermittelt; apos liefert die Positionen und sl die
// gematchten Strings
// Beispiel: matchall(ss,0,name,apos,sl) liefert alle Namen in ss
begin
result:=matchall(s,0,pat,apos,sl);
end;
function matchall(s:string;pat:array of const;var apos:arrayofinteger;var sl:arrayofstring):integer;
// Analog mit der Paternfolge pat
begin
result:=matchall(s,0,pat,apos,sl);
end;
function matchall(s:string;pat:tpattern;var sl:arrayofstring):integer;
// In s werden alle Teilstrings, die pat matchen ermittelt; sl liefert die gematchten Strings
// Beispiel: matchall(ss,0,name,sl) liefert alle Namen in ss
begin
result:=matchall(s,0,pat,sl);
end;
function matchall(s:string;pat:array of const;var sl:arrayofstring):integer;
// Analog mit der Paternfolge pat
begin
result:=matchall(s,0,pat,sl);
end;

procedure substitutefile(const quelle,ziel:string;arr,newstr:array of const;
rep:boolean=false;rek:boolean=false;ancho:boolean=false;ab:integer=0);
// in Datei quelle wird in jeder Zeile replace(arr,newstr) gemacht
// die gnderten Zeile nach ziel
var f1,f2:text;
 s,ss:string;
 pat:tpat;
 cat:tcat;
begin
if quelle<>''then begin
 assignfile(f1,quelle);reset(f1);
end;
if ziel<>''then begin
 assign(f2,ziel);rewrite(f2);
end;
pat:=tpat.create(arr);
cat:=tcat.create(newstr);
while (quelle='')or not eof(f1) do begin
 if quelle='' then begin
  readln(s);
  if s=''then break;
 end else readln(f1,s);
 ss:=replace(s,pat,cat,rep,rek,ancho,ab);
 if ziel='' then writeln(ss) else writeln(f2,ss);
end;
if quelle<>'' then close(f1);
if ziel<>'' then close(f2);
end;

function list2string(list:tlist):string;
var i:integer;
 obj:tobject;
begin
result:='';
for i:=0 to list.Count-1 do begin
 obj:=tobject(list[i]);
 if obj is tstring then result:=result+(obj as tstring).s
 else if obj is tinteger then result:=result+inttostr((obj as tinteger).x)
 else if obj is tsv then result:=result+(obj as tsv).compute
end;
end;

function getfields(s:string):tstringlist;overload;
var p1,apos,alen:integer;
 s1:string;
begin
result:=tstringlist.Create;
p1:=0;
while mat(s,p1,[blanks,upto(' ',s1)],apos,alen)and (s1<>'')do begin
 result.Add(s1);
 p1:=apos+alen;
end;
end;
function getfields(s:string;quotestr:string):tstringlist;overload;
var p1,apos,alen:integer;
 s1:string;
begin
result:=tstringlist.Create;
p1:=0;
while mat(s,p1,[findq(' ',quotestr,#0,s1)],apos,alen)and (s1<>'')do begin
 result.Add(s1);
 p1:=apos+alen+1;
end;
s1:=copy(s,p1+1,10000);s1:=trim(s1);
if s1<>'' then result.add(s1);
end;
function getfields(s:string;trenner,quotestr:string;triml:boolean=false;trimr:boolean=false):tstringlist;
overload;
var p1,apos,alen:integer;
 s1,s2:string;
begin
result:=tstringlist.Create;
p1:=0;
while mat(s,p1,[findwithq(trenner,quotestr,#0,s1,s2)],apos,alen)and (s1<>'')do begin
 if triml then s1:=trimleft(s1);
 if trimr then s1:=trimright(s1);
 result.Add(s1);
 p1:=apos+alen+length(trenner);
end;
s1:=copy(s,p1+1,10000);s2:=trim(s1);
if s2<>'' then result.add(s1);
end;

procedure filefilter(quelle,ziel:string;proc:tsubprocedure);
var f1,f2:text;
 s1,s2:string;
 sl:tstringlist;
 nurgeaendert:boolean;
 i:integer;
begin
nurgeaendert:=false;
sl:=tstringlist.create;
if (ziel<>quelle)and(ziel<>'')and(ziel[1]='-')then begin
 nurgeaendert:=true;delete(ziel,1,1);
end;
system.assign(f1,quelle);reset(f1);
while not eof(f1) do begin
 readln(f1,s1);
 proc(s1,s2);
 if (not nurgeaendert)or(s2<>s1)then sl.add(s2)
end;
close(f1);
system.Assign(f2,ziel);rewrite(f2);
for i:=0 to sl.count-1 do writeln(f2,sl[i]);
sl.free;
close(f2);
end;
procedure textfilter(quelle,ziel:string;proc:tsubprocedure);
var f1,f2:text;
 s1,s2:string;
 ss:string;
 i:integer;
begin
system.assign(f1,quelle);reset(f1);
ss:='';
while not eof(f1)do begin
 readln(f1,s1);
 ss:=ss+s1+#13#10;
end;
close(f1);
proc(ss,s2);
system.Assign(f2,ziel);rewrite(f2);
i:=system.pos(#13#10,s2);
while i>0 do begin
 ss:=system.copy(s2,1,i-1);
 writeln(f2,ss);
 system.delete(s2,1,i+1);
 i:=system.pos(#13#10,s2);
end;
close(f2);
end;

procedure filetest(quelle,ziel:string;proc:tsubprocedure;mitzeilennr:boolean);
var f1,f2:text;
 s1,s2:string;
 zeile:integer;
begin
system.assign(f1,quelle);reset(f1);
system.Assign(f2,ziel);rewrite(f2);
zeile:=0;
while not eof(f1) do begin
 inc(zeile);
 readln(f1,s1);
 proc(s1,s2);
 if s2<>'' then begin
  if mitzeilennr then write(f2,zeile:6,' ');
  writeln(f2,s2);
 end;
end;
close(f1);
close(f2);
end;
procedure filetest(quelle,ziel:string;proc:tsubprocedure);
begin
filetest(quelle,ziel,proc,false);
end;
(*
function CopyProgressRoutine(TotalFileSize,TotalBytesTransferred,StreamSize,StreamBytesTransferred:int64;
                             dwStreamNumber,dwCallbackReason:dword;
                             hSourceFile,hDestinationFile:thandle;data:pointer
//  __in_opt  LPVOID lpData
):dword;stdcall;
var prozent:single;
 prozi:integer;
 s:string;
 resw:word;
begin

application.processmessages;
if Main.vabbruch then begin
 Main.vabbruch:=false;
 dohalt('Abbruch durch Benutzer');
end;
if Main.vanhalten then begin
 Main.vanhalten:=false;
 resw:=MessageDlg('Anhalten beim Kopieren Weiter',mtconfirmation,[mbyes,mbabort],0);
 if resw=mrabort then dohalt('Abbruch durch Benutzer');
end;
if totalfilesize=0 then prozi:=100
else begin
 prozent:=totalbytestransferred/Totalfilesize;
 prozi:=round(prozent*100);
end;
s:=inttostr(prozi);
if length(s)=1 then s:='  '+s
else if length(s)=2 then s:=' '+s;;
zchange(s);
if totalbytestransferred<Totalfilesize then result:=PROGRESS_CONTINUE else result:=PROGRESS_QUIET;
end;
*)
procedure filerename(qdir:string;proc:tsubprocedure);
begin
filecopy(qdir,'',proc);
end;
procedure filecopy(qdir,zdir:string;proc:tsubprocedure);
var sr: TSearchRec;
 //vbool:longbool;
 qname,zname,s1,s2:string;
 //res:longbool;
begin
qdir:=IncludeTrailingPathDelimiter(qdir);
if zdir<>''then begin
 if not DirectoryExists(zdir) then ForceDirectories(zdir);
 zdir:=IncludeTrailingPathDelimiter(zdir);
end;
if sysutils.FindFirst(qdir+'*.*', faanyfile, sr) = 0 then begin
 repeat
  s1:=sr.name;
  proc(s1,s2);
  if s2<>'' then begin
   qname:=qdir+s1;
   if zdir='' then begin //umbenennen
    zname:=qdir+s2;
    RenameFile(qname,zname);
   end else begin // Kopieren
    zname:=zdir+s2;
    //todo copyfileex bei Lazarus nicht gefunden
    //{res:=}copyfileex(@qname[1],@zname[1],nil{@CopyProgressRoutine},NIL,@vbool,8);//COPY_FILE_ALLOW_DECRYPTED_DESTINATION);
    {res:=}copyfile(@qname[1],@zname[1],true);//COPY_FILE_ALLOW_DECRYPTED_DESTINATION);
   end;
  end;
 until sysutils.FindNext(sr) <> 0;
 sysutils.FindClose(sr);
end;
end;

procedure ignorecase(a:integer);
begin
ignorecaseglb:=a<>0;
end;
procedure debug(a:integer);
begin
trace(a);
end;
procedure trace(mode:integer);overload;
begin
trace(mode,'');
end;
procedure trace(mode:integer;name:string);overload;
begin
mode:=mode mod 10;
debug1:=false;debug2:=false;
if mode in [1,2] then debug1:=true;
if mode=2 then debug2:=true;
assign(tracefile,name);
traceoutput:=name='';
if not traceoutput then begin
 assign(tracefile,name);rewrite(tracefile);close(tracefile);
end;
end;
procedure trace(mode:integer;name:string;atracestr:string);overload;
begin
trace(mode,name);
tracestr:=atracestr;
end;
procedure anchor(a:integer);
begin
anchorglb:=a<>0;
end;
procedure greedy(a:integer);
begin
greedyglb:=a<>0;
end;
function getname(var s:string):tpattern;
begin
result:=pat(name,s);
end;
procedure doanchorglb(v:boolean);
begin
anchorglb:=v;
end;
{
function count(sl:array of string):integer;
begin
result:=sl.length;
end;
function count(sl:tmystringlist):integer;
begin
result:=sl.count;
end;
function count(arr:tarray):integer;
begin
result:=arr.count;
end;
function count(arr:array of const):integer;overload;
begin
result:=length(arr);
end;
}
begin
blanks:=span(' ');
name:=pat([any(letters),span(namechars)]);
number:=pat([any(digits),span(digits)]);
end.
