unit mystring;
{Copyright 2009 Manfred Rosendahl
 Private Nutzung erlaubt
 Bei kommerzieller Nutzung bitte Mail an: ros at uni-koblenz.de
}
{  Achtung diese Routine ist von der eingestellten String version abhngig
    Daher bei jedem Projekt immer einmal mitbersetzen (Bild statt make)
}
interface
uses classes;
type tcharset=set of char;
 charset=tcharset;
 arrayofinteger=array of integer;
 arrayofstring=array of string;
 arrayofpointer=array of pointer;

 tboolarrfunction=function(arr:array of pointer):boolean;
 tboolfunction=function:boolean;
 tboolpointerfunction=function(p:pointer):boolean;

 tarrproc=procedure(arr:array of pointer);
 tprocedure=procedure;
 tpointerproc=procedure(p:pointer);
 tstringprocedure=procedure(s:string);

const letters:tcharset=['A'..'Z','a'..'z','','','','','','',''];
 digits:tcharset=['0'..'9'];
 namechars:tcharset=['0'..'9','A'..'Z','a'..'z','','','','','','','','_'];


const ansiuml:set of char=['','','','','','',''];
const buzi:set of char=['0'..'9','A'..'Z','a'..'z','','','','','','',''];
function blanks(n:integer):string;
// String aus n Blanks
procedure formatstr(var s:string;delblankslinks,delblanksrechts,ausrichtenlinks:boolean;
 laenge:integer);
 // String s wird auf laenge gebracht. Vorher delblanksrechts,delblankslinks ausfhren.
 // beu ausrichtenlinks rechts blanks einfgen sonst links. abschneiden immer rechts
 // bei laenge=0 keine Lngennderung
function inttostrf(i:integer;l:integer):string;
procedure delblanks(var s:string;delblankslinks,delblanksrechts:boolean);
// String delblanksrechts,delblankslinks ausfhren.
function fdelblanks(s:string;delblankslinks,delblanksrechts:boolean):string;
// String delblanksrechts,delblankslinks ausfhren.

function tokenize(astr:string;const delimiter:string;klaauf,klazu,quoteauf,quotezu:arrayofstring;slash:char):arrayofstring;
overload;
function tokenize(s:string;const delimiter:string):arrayofstring;overload;
// Teilt s an den Trennern delimiter
function tokenize(s:string;const delimiter,klastr:string):arrayofstring;overload;
function tokenize(s:string;const delimiter,klastr,quotestr:string):arrayofstring;overload;
function tokenize(s:string;const delimiter,klastr,quotestr:string;aslash:char):arrayofstring;overload;

function find(const suchstr:string;instr:string;ab:integer):integer;
// Sucht suchstr in instr ab Position ab
function replace(const suchstr,replacestr:string;var instr:string;ab:integer):integer;
// Ersetz suchstr durch erplacestr in instr ab Position ab Funktionswert: Stelle wo suchstr gefunden
function findcase(suchstr:string;instr:string;ab:integer):integer;
// findstring ohne gross-klein
function replacecase(suchstr:string;const replacestr:string;var instr:string;ab:integer):integer;
// Ersetz suchstr durch erplacestr in instr ab Position ab Funktionswert: Stelle wo suchstr gefunden
// ohne gross klein
function leadingblanks(const s:string):integer;
function isend(const endstr,s:string):boolean;
function isatpos(const posstr,s:string;pos:integer):boolean;
//posstr ist in s an position pos
function rep(const s:string;n:integer):string;
// s wird n mal wiederholt
function errorstring(error:integer):string;
//Liefert die Fehlerbeschreibung zu error Windows: formatstring
function filename(dir:string;const name:string):string;
// Erzeugt Dateinamen aus Verzeichnis  und namen
function blanksonly(const s:string):boolean;
function isinstrings(const s:string;strings:array of const):boolean;
// s ist in strings
function readline(const f:text;var s:string):boolean;
// wenn noch nicht eof(f) wird eine Zeile gelesen
function IsLike(AString, Pattern: string): boolean;
procedure dofiles(fname:string;proc:tstringprocedure);
function linksbuendig(s:string;l:integer):string;
function rechtsbuendig(s:string;l:integer):string;
// Recursive procedure to build a list of files
procedure FindFiles(FilesList: TStringList; StartDir, FileMask: string;rek:boolean);

implementation
uses windows,strutils,sysutils;

function errorstring(error:integer):string;
//Liefert die Fehlerbeschreibung zu error
var errorstr:pchar;
begin
windows.formatmessage(format_message_allocate_buffer or format_message_from_system,
nil,error,0,@errorstr,0,nil);
result:=errorstr;
//strdispose(errorstr);
end;

function filename(dir:string;const name:string):string;
begin
if (length(dir)>0)and(not(dir[length(dir)] in[':','\'])) then dir:=dir+'\';
result:=dir+name;
end;

function rep(const s:string;n:integer):string;
begin
result:=dupestring(s,n);
end;

function isend(const endstr,s:string):boolean;
begin
result:=(length(s)>=length(endstr))and(copy(s,length(s)-length(endstr)+1,maxint)=endstr);
end;
function isatpos(const posstr,s:string;pos:integer):boolean;
//posstr ist in s an position pos
begin
result:=system.copy(s,pos,length(posstr))=posstr;
end;

function leadingblanks(const s:string):integer;
begin
result:=0;
while (result<length(s))and(s[result+1]=' ')do inc(result);
end;

function find(const suchstr:string;instr:string;ab:integer):integer;
begin
system.delete(instr,1,ab-1);
result:=system.pos(suchstr,instr);
if result>0 then inc(result,ab-1);
end;

function findcase(suchstr:string;instr:string;ab:integer):integer;
begin
suchstr:=lowercase(suchstr);
instr:=lowercase(instr);
system.delete(instr,1,ab-1);
result:=system.pos(suchstr,instr);
if result>0 then inc(result,ab-1);
end;

function replace(const suchstr,replacestr:string;var instr:string;ab:integer):integer;
// Ersetz suchstr durch replacestr in instr ab Position ab Funktionswert: Stelle wo suchstr gefunden
var s2,s1:string;
begin
s2:=system.copy(instr,ab,maxint);
result:=system.pos(suchstr,s2);
if result>0 then begin
 s1:=system.copy(instr,1,ab-1+result-1);
 s2:=system.copy(instr,ab-1+result+length(suchstr),maxint);
 instr:=s1+replacestr+s2;
end;
end;
function replacecase(suchstr:string;const replacestr:string;var instr:string;ab:integer):integer;
// Ersetz suchstr durch erplacestr in instr ab Position ab Funktionswert: Stelle wo suchstr gefunden
var s2,s1:string;
begin
s2:=lowercase(system.copy(instr,ab,maxint));
result:=system.pos(lowercase(suchstr),s2);
if result>0 then begin
 s1:=system.copy(instr,1,ab-1+result-1);
 s2:=system.copy(instr,ab-1+result+length(suchstr),maxint);
 instr:=s1+replacestr+s2;
end;
end;

function tokenize(s:string;const delimiter:string):arrayofstring;
var i:integer;
 res:tstringlist;
begin
res:=tstringlist.create;
i:=pos(delimiter,s);
while i>0 do begin
 res.add(system.copy(s,1,i-1));
 system.delete(s,1,i+length(delimiter)-1);
 i:=pos(delimiter,s);
end;
if s<>''then res.add(s);
setlength(result,res.count);
for i:=0 to res.count-1 do result[i]:=res[i];
end;

function tokenize(astr:string;const delimiter:string;klaauf,klazu,quoteauf,quotezu:arrayofstring;slash:char):arrayofstring;
var i,j,ipos,apos,iendpos:integer;
 stack:tstringlist;
 s2,s3:string;
 res:tstringlist;
label 1;
begin
ipos:=1; // Basis 1
apos:=1;
stack:=tstringlist.create;
res:=tstringlist.Create;
while ipos<=length(astr) do begin
 if stack.count=0 then begin
  // An dieser Stelle kann delimiter kommen
  if isatpos(delimiter,astr,ipos) then begin
   res.add(system.copy(astr,apos,ipos-apos));
   apos:=ipos+length(delimiter);
   ipos:=apos;
   goto 1;
  end;
 end;
 if (slash<>#0)and(astr[ipos]=slash)then begin
  inc(ipos,2);goto 1;
 end;
 if quoteauf<>nil then begin
  for j:=0 to length(quoteauf)-1 do begin
   s2:=quoteauf[j];
   if isatpos(s2,astr,ipos)then begin // in quote ende suchen
    s3:=quotezu[j];
    iendpos:=ipos+length(s2);
    while iendpos<length(astr) do begin
     if isatpos(s3,astr,iendpos)then begin  // ende quote
      inc(iendpos,length(s3));break;
     end else inc(iendpos,1);
    end;
    ipos:=iendpos;goto 1;
   end;
  end;
  for j:=0 to length(quotezu)-1 do begin
   s2:=quotezu[j];
   if isatpos(s2,astr,ipos)then begin // quote ende gefunden Text har Fehler
    setlength(result,0);exit;
   end;
  end;
 end;
 if klaauf<>nil then begin
  for j:=0 to length(klaauf)-1 do begin
   s2:=klaauf[j];
   if isatpos(s2,astr,ipos)then begin // klaauf
    s3:=klazu[j];
    stack.add(s3);
    ipos:=ipos+length(s2);goto 1;
   end;
  end;
  for j:=0 to length(klazu)-1 do begin
   s2:=klazu[j];
   if isatpos(s2,astr,ipos+1) then begin // klazu
    if (stack.count>0)and(stack[stack.Count-1]=s2) then begin
     inc(ipos,length(s2));
     stack.delete(stack.count-1);
     goto 1;
    end else begin
     result:=nil;exit;
    end;
   end;
  end;
 end;
 inc(ipos); //weder slash noch quote noch klaauf noch klazu
 1:
end;
if apos<length(astr)then res.add(system.copy(astr,apos,length(astr)));
stack.Free;
setlength(result,res.count);
for i:=0 to res.count-1 do result[i]:=res[i];
end;
procedure makeklammer(var klaauf,klazu:arrayofstring;klastr:string);
var i,l,l2:integer;
 sl:tstringlist;
 trenner:char;
begin
if klastr=''then begin
 klaauf:=nil;klazu:=nil;
end else begin
 sl:=tstringlist.Create;
 if length(klastr)=1 then sl.add(klastr)
 else begin
  trenner:=klastr[1];system.delete(klastr,1,1);
  i:=system.pos(trenner,klastr);
  while i>0 do begin
   sl.add(system.copy(klastr,1,i-1));
   delete(klastr,1,i);
   i:=system.pos(trenner,klastr);
  end;
  if klastr<>''then sl.add(klastr);
 end;
 l:=sl.count;
 l2:=l div 2;
 if odd(l)then begin
  setlength(klaauf,l2);
  setlength(klazu,l2);
 end else begin
  setlength(klaauf,l2+1);
  setlength(klazu,l2+1);
 end;
 for i:=1 to l2 do begin
  klaauf[2*i-2]:=sl[2*i-2];
  klazu[2*i-1]:=sl[2*i-1];
 end;
 if odd(l)then begin
  klaauf[l2]:=sl[l-1];
  klazu[l2]:=sl[l-1];
 end;
end;
end;

function tokenize(s:string;const delimiter,klastr:string):arrayofstring;overload;
var klaauf,klazu:arrayofstring;
begin
makeklammer(klaauf,klazu,klastr);
result:=tokenize(s,delimiter,klaauf,klazu,nil,nil,#0);
end;
function tokenize(s:string;const delimiter,klastr,quotestr:string):arrayofstring;overload;
var klaauf,klazu,quoteauf,quotezu:arrayofstring;
begin
makeklammer(klaauf,klazu,klastr);
makeklammer(quoteauf,quotezu,quotestr);
result:=tokenize(s,delimiter,klaauf,klazu,quoteauf,quotezu,#0);
end;
function tokenize(s:string;const delimiter,klastr,quotestr:string;aslash:char):arrayofstring;overload;
var klaauf,klazu,quoteauf,quotezu:arrayofstring;
begin
makeklammer(klaauf,klazu,klastr);
makeklammer(quoteauf,quotezu,quotestr);
result:=tokenize(s,delimiter,klaauf,klazu,nil,nil,aslash);
end;

function blanks(n:integer):string;
begin
result:=DupeString(' ',n);
end;

procedure delblanks(var s:string;delblankslinks,delblanksrechts:boolean);
 // String delblanksrechts,delblankslinks ausfhren.
var l,nlinks,nrechts:integer;
begin
if delblankslinks then begin
 nlinks:=0;
 while (nlinks<length(s))and(s[nlinks+1]=' ') do inc(nlinks);
 delete(s,1,nlinks);
end;
if delblanksrechts then begin
 nrechts:=0;
 l:=length(s);
 while (l>nrechts)and(s[l-nrechts]=' ') do inc(nrechts);
 delete(s,length(s)-nrechts+1,nrechts);
end;
end;
function fdelblanks(s:string;delblankslinks,delblanksrechts:boolean):string;
// String delblanksrechts,delblankslinks ausfhren.
begin
delblanks(s,delblankslinks,delblanksrechts);
result:=s;
end;
procedure formatstr(var s:string;delblankslinks,delblanksrechts,ausrichtenlinks:boolean;
 laenge:integer);
 // String s wird auf laenge gebracht. Vorher delblanksrechts,delblankslinks ausfhren.
 // beu ausrichtenlinks rechts blanks einfgen sonst links. abschneiden immer rechts
 // bei laenge=0 keine Lngennderung
var nlinks,nrechts,dlaenge:integer;
begin
if delblankslinks then begin
 nlinks:=0;
 while (nlinks<length(s))and(s[nlinks+1]=' ') do inc(nlinks);
 delete(s,1,nlinks);
end;
if delblanksrechts then begin
 nrechts:=0;
 while (length(s)>nrechts)and(s[length(s)-nrechts-1]=' ') do inc(nrechts);
 delete(s,length(s)-nrechts,nrechts);
end;
if laenge>0 then begin
 if length(s)>laenge then setlength(s,laenge)
 else if length(s)<laenge then begin
  dlaenge:=laenge-length(s);
  if ausrichtenlinks then s:=s+blanks(dlaenge)
  else s:=blanks(dlaenge)+s;
 end;
end;
end;

function blanksonly(const s:string):boolean;
var i:integer;
begin
result:=true;
for i:=1 to length(s) do if s[i]<>' 'then begin
 result:=false;exit;
end;
end;

function isinstrings(const s:string;strings:array of const):boolean;
var v:tvarrec;
 i:integer;
begin
result:=true;
for i:=0 to high(strings) do begin
 v:=strings[i];
 if (v.VType=vtansistring)and (string(v.vansistring)=s) then exit;
end;
result:=false;
end;

function readline(const f:text;var s:string):boolean;
// wenn noch nicht eof(f) wird eine Zeile gelesen
begin
if eof(f) then begin
 result:=false;s:='';
end else begin
 result:=true;readln(f,s);
end;
end;

function inttostrf(i:integer;l:integer):string;
begin
result:=inttostr(i);
formatstr(result,false,false,false,4)
end;

function IsLike(AString, Pattern: string): boolean;
var
   j, n, n1, n2: integer ;
   p1, p2: pchar ;
label
   match, nomatch;
begin
   AString := UpperCase(AString) ;
   Pattern := UpperCase(Pattern) ;
   n1 := Length(AString) ;
   n2 := Length(Pattern) ;
   if n1 < n2 then n := n1 else n := n2;
   p1 := pchar(AString) ;
   p2 := pchar(Pattern) ;
   for j := 1 to n do begin
     if p2^ = '*' then goto match;
     if (p2^ <> '?') and ( p2^ <> p1^ ) then goto nomatch;
     inc(p1) ; inc(p2) ;
   end;
   if n1 > n2 then begin
nomatch:
     Result := False;
     exit;
   end else if n1 < n2 then begin
     for j := n1 + 1 to n2 do begin
       if not ( p2^ in ['*','?'] ) then goto nomatch ;
       inc(p2) ;
     end;
   end;
match:
   Result := True
end;
procedure dofiles(fname:string;proc:tstringprocedure);
var Ff: TSearchRec;
 name,path:string;
begin
path:=extractfilepath(fname);
if findfirst(fname,faanyfile,ff)=0 then begin
 repeat
  name:=path+ff.name;
  proc(name);
 until findnext(ff)<>0;
end;
end;

function linksbuendig(s:string;l:integer):string;
begin
formatstr(s,true,true,true,l);
result:=s;
end;

function rechtsbuendig(s:string;l:integer):string;
begin
formatstr(s,true,true,false,l);
result:=s;
end;

// Recursive procedure to build a list of files
procedure FindFiles(FilesList: TStringList; StartDir, FileMask: string;rek:boolean);
var
  SR: TSearchRec;
  DirList: TStringList;
  IsFound: Boolean;
  i: integer;
begin
  if StartDir[length(StartDir)] <> '\' then
    StartDir := StartDir + '\';

  { Build a list of the files in directory StartDir
     (not the directories!)                         }

  IsFound :=
    FindFirst(StartDir+FileMask, faAnyFile-faDirectory, SR) = 0;
  while IsFound do begin
    FilesList.Add(StartDir + SR.Name);
    IsFound := FindNext(SR) = 0;
  end;
  FindClose(SR);
  if rek then begin
   // Build a list of subdirectories
   DirList := TStringList.Create;
   IsFound := FindFirst(StartDir+'*.*', faAnyFile, SR) = 0;
   while IsFound do begin
     if ((SR.Attr and faDirectory) <> 0) and
          (SR.Name[1] <> '.') then
       DirList.Add(StartDir + SR.Name);
     IsFound := FindNext(SR) = 0;
   end;
   FindClose(SR);

   // Scan the list of subdirectories
   for i := 0 to DirList.Count - 1 do
     FindFiles(FilesList, DirList[i], FileMask,true);

   DirList.Free;
  end; 
end;

end.
